/*
 * This file is part of the Alliance CAD System
 * Copyright (C) Laboratoire LIP6 - Dpartement ASIM
 * Universite Pierre et Marie Curie
 * 
 * Home page          : http://www-asim.lip6.fr/alliance/
 * E-mail support     : mailto:alliance-support@asim.lip6.fr
 * 
 * This progam is  free software; you can redistribute it  and/or modify it
 * under the  terms of the GNU  General Public License as  published by the
 * Free Software Foundation;  either version 2 of the License,  or (at your
 * option) any later version.
 * 
 * Alliance VLSI  CAD System  is distributed  in the hope  that it  will be
 * useful, but WITHOUT  ANY WARRANTY; without even the  implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details.
 * 
 * You should have received a copy  of the GNU General Public License along
 * with the GNU C Library; see the  file COPYING. If not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/***
*	ERIC CHABOD
*	ANTOINE MARTIN
*	D.E.A. M.E.M.I. 1992
*
*   Laurent WINCKEL
*
*	PROJET BSG : Barrel Shifter Generator
*
*	NOM:	 bsg_netl.c
*   VERSION: 2.00
*	DATE:	 (29/09/1993)
*	OBJET:	 generation de la netlist.
*/

static char *netl_ident="@(#)(BSG) netlist view generation, version 2.00 (29/09/1993)";

static void gen_netlist( msb0 )
long msb0;
{
	long i;

	GENLIB_DEF_LOFIG( name );


	if ( msb0 )	
		for( i = 0; i <= ad_size; i++ )
			GENLIB_LOCON( GENLIB_NAME( "in_s[%d]", i ), IN, GENLIB_NAME( "in_s[%d]", i ) );
	else
		for( i = ad_size; i >= 0; i-- )
			GENLIB_LOCON( GENLIB_NAME( "in_s[%d]", i ), IN, GENLIB_NAME( "in_s[%d]", i ) );

	GENLIB_LOCON( "left", IN, "left" );
	GENLIB_LOCON( "rot", IN, "rot" );
	GENLIB_LOCON( "ext", IN, "ext" );

	if ( msb0 )	
	{
		for( i = 0; i <= size; i++ )
			GENLIB_LOCON( GENLIB_NAME( "in_d[%d]", i ), IN, GENLIB_NAME( "in_d[%d]", i ) );
	
		for( i = 0; i <= size; i++ )
			GENLIB_LOCON( GENLIB_NAME( "out_d[%d]", i ), OUT, GENLIB_NAME( "out_d[%d]", i ) );
	}
	else
	{
		for( i = size; i >= 0; i-- )
			GENLIB_LOCON( GENLIB_NAME( "in_d[%d]", i ), IN, GENLIB_NAME( "in_d[%d]", i ) );

		for( i = size; i >= 0; i-- )
			GENLIB_LOCON( GENLIB_NAME( "out_d[%d]", i ), OUT, GENLIB_NAME( "out_d[%d]", i ) );
	}

	/***
	*	alimentations
	*/
#ifdef  PUT_ALIM
	GENLIB_LOCON( "vdd", IN, "vdd" );
	GENLIB_LOCON( "vss", IN, "vss" );
#endif

	GENLIB_SAVE_LOFIG();
/*
	PRINTF( "Netlist generated...\n" );
*/
}
