#include "C4_check.h"

/************************************************************************/
/*	Fonction C4_test_NOT()																							*/
/************************************************************************/
int 
C4_test_NOT(ablexpr *ABL)
{
if (ABL_ATOM (ABL)) return 0;
if (ABL_OPER (ABL) == ABL_NOT) return 1;
else return 2;
}

/************************************************************************/
/*	Fonction C4_expr_AND_OR()																						*/
/*																																			*/
/*	Cette fonction verifie l'absence d'operateurs 											*/
/*	NOT/XOR/NOR/NAND/NXOR dans l'expression a synthetiser								*/
/************************************************************************/
int 
C4_expr_AND_OR(ablexpr *ABL)
{
  ablexpr *pt=ABL;
  int r;

  if (ABL_ATOM(ABL)) return (1);

  if (isabloperinexpr (ABL, ABL_NOT)) return(0);
  if (isabloperinexpr (ABL, ABL_XOR)) return(0);
  if (isabloperinexpr (ABL, ABL_NOR)) return(0);
  if (isabloperinexpr (ABL, ABL_NAND)) return(0);
  if (isabloperinexpr (ABL, ABL_NXOR)) return(0);
  r=1;
  while (pt->NEXT)
  {
          pt=pt->NEXT;
          r=r*C4_expr_AND_OR(pt->DATA);
  }
  return (r);
}

/************************************************************************/
/*	fonction C4_pas_de_double()																					*/
/*																																			*/
/*	Cette fonction verifie qu'aucune variable n'est instanciee					*/
/*	plus d'une fois																											*/
/************************************************************************/
int
C4_pas_de_double (authtable *Table, ablexpr *ABL)
{
  char *name;
  ablexpr *pt;
  int r;
  authelem *Element;

  if ((ABL_ATOM (ABL)) && (strcmp (ABL_ATOM_VALUE (ABL), C4_FICTIVE))) 
	{
	name = ABL_ATOM_VALUE (ABL);/*------------------------------------------------------------\
|                                                             |
| This file is part of the Alliance CAD System Copyright      |
| (C) Laboratoire LIP6 - Dpartement ASIM Universite P&M Curie|
|                                                             |
| Home page      : http://www-asim.lip6.fr/alliance/          |
| E-mail support : mailto:alliance-support@asim.lip6.fr       |
|                                                             |
| This progam is  free software; you can redistribute it      |
| and/or modify it under the  terms of the GNU Library General|
| Public License as published by the Free Software Foundation |
| either version 2 of the License, or (at your option) any    |
| later version.                                              |
|                                                             |
| Alliance VLSI  CAD System  is distributed  in the hope that |
| it  will be useful, but WITHOUT  ANY WARRANTY;              |
| without even the  implied warranty of MERCHANTABILITY or    |
| FITNESS FOR A PARTICULAR PURPOSE. See the GNU General       |
| Public License for more details.                            |
|                                                             |
| You should have received a copy  of the GNU General Public  |
| License along with the GNU C Library; see the file COPYING. |
| If not, write to the Free Software Foundation, Inc.,        |
| 675 Mass Ave, Cambridge, MA 02139, USA.                     |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------\
|                                                       |
|  Title   :             C4_check												|
|                                                       |
|  Date    :             30.10.01                       |
|                                                       |
|  Authors :  Greiner Alain, Beaudenon Vincent          |
|                                                       |
\------------------------------------------------------*/


        Element = searchauthelem (Table, namealloc(name));
	if (Element != (authelem *) 0) {
		return 0;
		}
        else {
		addauthelem (Table, namealloc (name), 0);
		return 1;
	 	}
	}
  else
	{
	pt = ABL;
	r=1;
	while (ABL_CDR (pt))
		{
		pt = ABL_CDR (pt);
		r=r*C4_pas_de_double(Table, ABL_CAR (pt));
		}
	}
return r;
}

/************************************************************************/
/*	Fonction C4_check()																									*/
/*																																			*/
/*	Cette fonction retourne																							*/
/*		 0 si l'expression n'est pas synthetisable												*/
/*		 1 si l'expression est inverseuse         												*/
/*		 2 si l'expression est non-inverseuse															*/
/************************************************************************/
int 
C4_check (befig_list * BEFIG)
{
  int c;
  authtable *HashTable;

  HashTable = createauthtable (100);

  if(BEFIG->BEBUS != NULL) return (0);
  if(BEFIG->BEAUX != NULL) return (0);
  if(BEFIG->BEREG != NULL) return (0);
  if(BEFIG->BEOUT == NULL) return (0);
  if(BEFIG->BEOUT->NEXT != NULL) return (0);
  c = 1;
  c = c * C4_pas_de_double (HashTable, BEFIG->BEOUT->ABL);
  c = c * C4_test_NOT(BEFIG->BEOUT->ABL);
  if (c==1) c = c * C4_expr_AND_OR(ABL_CADR(BEFIG->BEOUT->ABL));
  if (c==2) c = c * C4_expr_AND_OR(BEFIG->BEOUT->ABL);

  destroyauthtable (HashTable);
  return (c);
}

