/*------------------------------------------------------------\
|                                                             |
| This file is part of the Alliance CAD System Copyright      |
| (C) Laboratoire LIP6 - Dpartement ASIM Universite P&M Curie|
|                                                             |
| Home page      : http://www-asim.lip6.fr/alliance/          |
| E-mail support : mailto:alliance-support@asim.lip6.fr       |
|                                                             |
| This progam is  free software; you can redistribute it      |
| and/or modify it under the  terms of the GNU Library General|
| Public License as published by the Free Software Foundation |
| either version 2 of the License, or (at your option) any    |
| later version.                                              |
|                                                             |
| Alliance VLSI  CAD System  is distributed  in the hope that |
| it  will be useful, but WITHOUT  ANY WARRANTY;              |
| without even the  implied warranty of MERCHANTABILITY or    |
| FITNESS FOR A PARTICULAR PURPOSE. See the GNU General       |
| Public License for more details.                            |
|                                                             |
| You should have received a copy  of the GNU General Public  |
| License along with the GNU C Library; see the file COPYING. |
| If not, write to the Free Software Foundation, Inc.,        |
| 675 Mass Ave, Cambridge, MA 02139, USA.                     |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------\
|                                                       |
|  Title   :             C4_lofig												|
|                                                       |
|  Date    :             30.10.01                       |
|                                                       |
|  Authors :  Greiner Alain, Beaudenon Vincent          |
|                                                       |
\------------------------------------------------------*/

#include "C4_lofig.h"

/************************************************************************/
/*	Fonction C4_netlist_put_in() 																				*/
/************************************************************************/

char *genTransName(PREFIXE,NAME)
				char *PREFIXE;
				char *NAME;
{
char *tmp,*new;
//printf("genName :%s%s\n",PREFIXE,NAME);
tmp  = malloc ((strlen(PREFIXE)+strlen(NAME)+1)*sizeof(char));
sprintf(tmp,"%s%s",PREFIXE,NAME);
new = namealloc(tmp);
free(tmp);
return new;
}

void C4_addTransN (LOFIG,NAME,GRILLE,DRAIN,SOURCE)
				lofig_list *LOFIG;
				char *NAME;
				losig_list *GRILLE;
				losig_list *DRAIN;
				losig_list *SOURCE;
//				losig_list *BULK;
{
addlotrs (LOFIG,TRANSN,0,0,20,1,0,0,0,0,GRILLE,SOURCE,DRAIN,getlosig(LOFIG,3),genTransName("TN_",NAME));
}

long C4_addInN(LOFIG,NAME,INDEX,up,down)
				lofig_list *LOFIG;
				char *NAME;
				long INDEX;
				losig_list *up;
				losig_list *down;
{
losig_list *sig;
sig = addlosig(LOFIG,INDEX,addchain(NULL,NAME),EXTERNAL);
addlocon(LOFIG,NAME,sig,IN);
C4_addTransN(LOFIG,NAME,sig,up,down);
return INDEX+1;
}


void C4_addTransP (LOFIG,NAME,GRILLE,DRAIN,SOURCE)
				lofig_list *LOFIG;
				char *NAME;
				losig_list *GRILLE;
				losig_list *DRAIN;
				losig_list *SOURCE;
//				losig_list *BULK;
{
addlotrs (LOFIG,TRANSP,0,0,20,1,0,0,0,0,GRILLE,SOURCE,DRAIN,getlosig(LOFIG,2),genTransName("TP_",NAME));
}

long C4_addInP(LOFIG,NAME,INDEX,up,down)
				lofig_list *LOFIG;
				char *NAME;
				long INDEX;
				losig_list *up;
				losig_list *down;
{
C4_addTransP(LOFIG,NAME,getlocon(LOFIG,NAME)->SIG,down,up);
return INDEX;
}


/************************************************************************/
/*	Fonction C4_netlist_createN()																				*/
/************************************************************************/

long C4_createN(LOFIG,ABL,INDEX,up,down)
				lofig_list *LOFIG;
				ablexpr *ABL;
				long INDEX;
				losig_list *up;
				losig_list *down;
{
char *signame;
ablexpr *ptr;
losig_list *sig;
int flag;
//viewablexpr(ABL,1); printf(" INDEX : %x\n",INDEX);
if (ABL_ATOM(ABL))
				if (strcmp(ABL_ATOM_VALUE(ABL),C4_FICTIVE)) return C4_addInN(LOFIG,ABL_ATOM_VALUE(ABL),INDEX,up,down);
				else return INDEX;
if (ABL_OPER(ABL)==ABL_OR) {
				flag = 1;
				for (ptr = ABL_CDR(ABL); ptr!=NULL; ptr = ABL_CDR(ptr)) {
								if (flag==1)
												INDEX = C4_createN(LOFIG,ABL_CAR(ptr),INDEX,up,down);
								else INDEX = C4_createN(LOFIG,ABL_CAR(ptr),INDEX,down,up);
								flag = -flag;
				}
				return INDEX;
}
for (ptr = ABL_CDR(ABL); ptr!=NULL; ptr = ABL_CDR(ptr)) {
				if ((ABL_CDR(ptr)) && (strcmp(ABL_ATOM_VALUE(ABL_CADR(ptr)),C4_FICTIVE)))
				{
//								INDEX++;
								if (strcmp(ABL_ATOM_VALUE(ABL_CAR(ptr)),C4_FICTIVE)) {
								signame = malloc(10*sizeof(char));
								sprintf(signame,"aux%x",INDEX);
								sig = addlosig(LOFIG,INDEX,addchain(NULL,namealloc(signame)),INTERNAL);
								INDEX++;
								INDEX = C4_createN(LOFIG,ABL_CAR(ptr),INDEX,sig,down);
								down = sig;}
//								INDEX = C4_createN(LOFIG,ABL_CAR(ptr),INDEX,up,sig);
//								up = sig;
				}
				else INDEX = C4_createN(LOFIG,ABL_CAR(ptr),INDEX,up,down);
}
return INDEX;
}

/************************************************************************/
/*	Fonction C4_netlist_createP()																				*/
/************************************************************************/
long C4_createP(LOFIG,ABL,INDEX,up,down)
				lofig_list *LOFIG;
				ablexpr *ABL;
				long INDEX;
				losig_list *up;
				losig_list *down;
{
char *signame;
ablexpr *ptr;
losig_list *sig;
int flag;
//viewablexpr(ABL,1); printf(" INDEX : %x\n",INDEX);
if (ABL_ATOM(ABL))
				if (strcmp(ABL_ATOM_VALUE(ABL),C4_FICTIVE)) return C4_addInP(LOFIG,ABL_ATOM_VALUE(ABL),INDEX,down,up);
				else return INDEX;
if (ABL_OPER(ABL)==ABL_AND) {
				flag = 1;
				for (ptr = ABL_CDR(ABL); ptr!=NULL; ptr = ABL_CDR(ptr)) {
								if (flag==1)
												INDEX = C4_createP(LOFIG,ABL_CAR(ptr),INDEX,up,down);
								else INDEX = C4_createP(LOFIG,ABL_CAR(ptr),INDEX,down,up);
								flag = -flag;
				}
				return INDEX;
}
for (ptr = ABL_CDR(ABL); ptr!=NULL; ptr = ABL_CDR(ptr)) {
				if ((ABL_CDR(ptr)) && (strcmp(ABL_ATOM_VALUE(ABL_CADR(ptr)),C4_FICTIVE)))
				{
					//			INDEX++;
						//		if (INDEX==37) viewablexpr(ABL,0);
								if (strcmp(ABL_ATOM_VALUE(ABL_CAR(ptr)),C4_FICTIVE)) {
																signame = malloc(10*sizeof(char));
								sprintf(signame,"aux%x",INDEX);
								sig = addlosig(LOFIG,INDEX,addchain(NULL,namealloc(signame)),INTERNAL);
								INDEX++;
								INDEX = C4_createP(LOFIG,ABL_CAR(ptr),INDEX,sig,down);
								down = sig;}
//								INDEX = C4_createP(LOFIG,ABL_CAR(ptr),INDEX,up,sig);
//								up = sig;
				}
				else INDEX = C4_createP(LOFIG,ABL_CAR(ptr),INDEX,up,down);
}
return INDEX;
}

//ADD BUFFER

void C4_addBuffer(LOFIG,NAME,BUFFER,SIGOUT,SIGVDD,SIGVSS)
				lofig_list *LOFIG;
				char *NAME;
				int BUFFER;
				losig_list *SIGOUT;
				losig_list *SIGVDD;
				losig_list *SIGVSS;
{
losig_list *sig1,*sig2;
if (BUFFER==1) {
	sig1 = addlosig(LOFIG,4,addchain(NULL,"C4_buff_sig"),INTERNAL);
	sig2 = addlosig(LOFIG,5,addchain(NULL,NAME),EXTERNAL);
	C4_addTransN(LOFIG,"C4_BUFFER1",SIGOUT,sig1,SIGVSS);
	C4_addTransP(LOFIG,"C4_BUFFER1",SIGOUT,sig1,SIGVDD);
	C4_addTransN(LOFIG,"C4_BUFFER2",sig1,sig2,SIGVSS);
	C4_addTransP(LOFIG,"C4_BUFFER2",sig1,sig2,SIGVDD);
}
else {
	sig2 = addlosig(LOFIG,4,addchain(NULL,NAME),EXTERNAL);
	C4_addTransN(LOFIG,"C4_BUFFER1",SIGOUT,sig2,SIGVSS);
	C4_addTransP(LOFIG,"C4_BUFFER1",SIGOUT,sig2,SIGVDD);
}
addlocon(LOFIG,NAME,sig2,OUT);				
}
				

/************************************************************************/
/*	Fonction C4_netlist()                 															*/
/*																																			*/
/*	Par convention le signal VDD a l'index 2,														*/
/*	le signal VSS a l'index 3 et le signal de sortie l'index 1					*/
/*	Il faut ajouter les transistors du buffer														*/
/************************************************************************/
lofig_list *
C4_netlist (befig_list * BEFIG,int buffer)
{
  lofig_list *LOFIG;
  long index;
  losig_list *sigvdd, *sigvss, *sigout;


  LOFIG = addlofig (BEFIG->NAME);

  sigout = addlosig (LOFIG, 1, addchain (NULL, "c4out"/*BEFIG->BEOUT->NAME*/), INTERNAL);
//  addlocon (LOFIG,BEFIG->BEOUT->NAME,sigout,OUT);

  sigvdd = addlosig (LOFIG, 2, addchain (NULL, "vdd"), EXTERNAL);
  addlocon (LOFIG, "vdd", sigvdd, IN);

  sigvss = addlosig (LOFIG, 3, addchain (NULL, "vss"), EXTERNAL);
  addlocon (LOFIG, "vss", sigvss, IN);

	C4_addBuffer(LOFIG,BEFIG->BEOUT->NAME,buffer,sigout,sigvdd,sigvss);
	
  if (buffer ==1) {
      index = C4_createN(LOFIG,ABL_CADR((BEFIG->BEOUT->ABL)), 6,
		sigout,sigvss);
       C4_createP(LOFIG,ABL_CADR(BEFIG->BEOUT->ABL), index,
		sigvdd,sigout);
      }
  else { 
	index = C4_createN(LOFIG,BEFIG->BEOUT->ABL, 5,
		sigout,sigvss);
	C4_createP(LOFIG,BEFIG->BEOUT->ABL, index,
		sigout,sigvdd);
      }
  return (LOFIG);
}

/************************************************************************/
/*	Fonctions auxiliaires pour C4_ordonne()															*/
/************************************************************************/
ablexpr *
C4_ordonne_addablexpr (ablexpr * abl, ablexpr * data)
{
  ablexpr *a;
  a = malloc (sizeof *a);
  a->NEXT = abl;
  a->DATA = data;
  return a;
}

ablexpr *
C4_ordonne_aboute (ablexpr * g, ablexpr * d)
{
  if (g)
    {
      ablexpr *pt = (g);
      while (pt->NEXT)
	pt = pt->NEXT;
      pt->NEXT = d;
      return (g);
    }
  else
    return (d);
}

/************************************************************************/
/*	Fonction C4_ordonne()						*/
/************************************************************************/
int 
C4_ordonne (ablexpr * ABL, int DIRECTION)
{
  int d, etat;
  ablexpr *pt, *un, *deux, *zero, *gauche, *droite;

  un = NULL;
  deux = NULL;
  zero = NULL;
  gauche = NULL;
  droite = NULL;
  d = DIRECTION;
  if ABL_ATOM
    (ABL) return 0;
  pt = ABL;
  while (ABL_CDR (pt))
    {
			pt = ABL_CDR (pt);
      etat = C4_ordonne (ABL_CAR (pt), d);
      if (etat == 0)
	zero = C4_ordonne_addablexpr (zero, ABL_CAR (pt));
      if (etat == 2)
	deux = C4_ordonne_addablexpr (deux, ABL_CAR (pt));
      if (etat == 1)
	{
	  un = C4_ordonne_addablexpr (un, ABL_CAR (pt));
	  d = -d;
	}
    }
  if (DIRECTION == C4_VINCENT_GAUCHE)
    {
      if ((un) && (d == C4_VINCENT_GAUCHE))
	{
	  droite = C4_ordonne_addablexpr (droite, ABL_CAR (un));
	  un = un->NEXT;
	}
      pt = un;
      while (pt)
	{
	  gauche = C4_ordonne_addablexpr (gauche, ABL_CAR (pt));
	  pt = pt->NEXT;
	}
      gauche = C4_ordonne_aboute (deux, gauche);
    }
  if (DIRECTION == C4_VINCENT_DROITE)
    {
      droite = deux;
      if ((un) && (d == C4_VINCENT_DROITE))
	{
	  droite = C4_ordonne_aboute (un->NEXT, droite);
	  gauche = un;
	  gauche->NEXT = NULL;
	}
      else
	droite = C4_ordonne_aboute (un, droite);
    }
  ABL_CDR (ABL) = C4_ordonne_aboute (gauche, C4_ordonne_aboute (zero, droite));

  if (getablexprlength (ABL) % 2)
    {
      if ((gauche) && (droite))
	return 2;
      if ((gauche) || (droite))
	return 1;
      return 0;
    }
  else
    {
      if (DIRECTION == C4_VINCENT_GAUCHE)
	addablhexpr (ABL, createablatom (C4_FICTIVE));
      else
	addablqexpr (ABL, createablatom (C4_FICTIVE));
      if ((gauche) && (droite))
	return 2;
      return 1;
    }
}

/************************************************************************/
/*	Fonction C4_lofig()						*/
/************************************************************************/
lofig_list *
C4_lofig (befig_list * BEFIG,int buffer)
{
lofig_list *LOFIG;

flatablexpr(BEFIG->BEOUT->ABL);  // pour eviter les (or(or(...)))

if (buffer==1) C4_ordonne(ABL_CADR(BEFIG->BEOUT->ABL), C4_VINCENT_GAUCHE);
else           C4_ordonne (BEFIG->BEOUT->ABL, C4_VINCENT_GAUCHE);

LOFIG=C4_netlist(BEFIG,buffer);
return (LOFIG);
}
