/*------------------------------------------------------------\
|                                                             |
| This file is part of the Alliance CAD System Copyright      |
| (C) Laboratoire LIP6 - Dpartement ASIM Universite P&M Curie|
|                                                             |
| Home page      : http://www-asim.lip6.fr/alliance/          |
| E-mail support : mailto:alliance-support@asim.lip6.fr       |
|                                                             |
| This progam is  free software; you can redistribute it      |
| and/or modify it under the  terms of the GNU Library General|
| Public License as published by the Free Software Foundation |
| either version 2 of the License, or (at your option) any    |
| later version.                                              |
|                                                             |
| Alliance VLSI  CAD System  is distributed  in the hope that |
| it  will be useful, but WITHOUT  ANY WARRANTY;              |
| without even the  implied warranty of MERCHANTABILITY or    |
| FITNESS FOR A PARTICULAR PURPOSE. See the GNU General       |
| Public License for more details.                            |
|                                                             |
| You should have received a copy  of the GNU General Public  |
| License along with the GNU C Library; see the file COPYING. |
| If not, write to the Free Software Foundation, Inc.,        |
| 675 Mass Ave, Cambridge, MA 02139, USA.                     |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------\
|                                                       |
|  Title   :           C4_topologie		  								|
|                                                       |
|  Date    :             30.10.01                       |
|                                                       |
|  Authors :  Greiner Alain, Beaudenon Vincent          |
|                                                       |
\------------------------------------------------------*/

#include "C4_topologie.h"

/**********************************************************
 * 												SHOW                            *
 **********************************************************/


void showSegment (SEG)
				C4_segment_list *SEG;
{
C4_segment_list *pt;
if (SEG==NULL) return;
pt = SEG;
while (pt!=NULL) {
				printf("%s : %s[%d] - %s[%d] : %d\n", getsigname(pt->SIG), pt->REF1->NOM, pt->INDEX1, pt->REF2->NOM, pt->INDEX2, pt->TAILLE);
				pt =pt->NEXT;
}
}

void showInstance (INS)
				C4_instance_list *INS;
{
C4_instance_list *pt;
int i;
if (INS==NULL) return;
pt = INS;
while(pt!=NULL) {
				printf("%d %s\t%s\t%s\t|",pt->INDEX,pt->NOM,getsigname(pt->GAUCHEN),getsigname(pt->DROITEN));
				for (i=C4_NBTOT -1; i>=0; i--) {
								if (pt->VIA[i]) printf("X");
								if (pt->SIG[i]) printf("%s\t|", getsigname(pt->SIG[i]));
								else printf("\t|");
				}
				printf("%s\t%s\t%s\n",getsigname(pt->GAUCHEP), getsigname(pt->DROITEP), pt->NOM);
				pt = pt->NEXT;
}
}

void C4_aff_fig (FIG)
				C4_fig_route *FIG;
{
if (FIG==NULL) return;
printf("\nFig Name : %s \n", FIG->NOM);
printf("\nInstance List :\n");
showInstance (FIG->INS);
printf("\nSegment List :\n");
showSegment(FIG->SEG);
}

/********************************************************
 * 										NEW																*
 ********************************************************/

C4_instance_list *newIns(NAME)
	char *NAME;
{
C4_instance_list *new;
int i;
new = malloc(sizeof *new);
new->INDEX = -1;
new->NOM = namealloc(NAME);
new->NEXT = NULL;
new->GAUCHEN = NULL;
new->GAUCHEP = NULL;
new->DROITEN = NULL;
new->DROITEP = NULL;
for (i=0; i<C4_NBTOT; i++) {
				new->VIA[i] = 0;
				new->SIG[i] = NULL;
}
//printf("New Ins : %s\n",new->NOM);
return new;
}

/********************************************************
 * 										PLACE															*
 ********************************************************/

C4_instance_list *C4_addInsFromName(LIST, NAME)
				C4_instance_list *LIST;
				char *NAME;
{
C4_instance_list *new;
if (LIST==NULL) return newIns(NAME);
//printf("LIST !=NULL\n");
if (namealloc(NAME)==LIST->NOM) return LIST;
new = newIns(NAME);
new->NEXT = LIST;
new->INDEX = LIST->INDEX-1;
return new;
}

C4_instance_list *C4_addInsFromABL(LIST, ABL)
				C4_instance_list *LIST;
				ablexpr *ABL;
{
ablexpr *pt;
//printf("AddABL :"); viewablexpr(ABL,1); printf("\n");
if (ABL_ATOM(ABL)) return C4_addInsFromName(LIST, ABL_ATOM_VALUE(ABL));
pt = ABL_CDR(ABL);
while (pt!=NULL) {
				LIST = C4_addInsFromABL(LIST, ABL_CAR(pt));
//				showInstance(LIST);
				pt = ABL_CDR(pt);
}
return LIST;
}

C4_instance_list *C4_placeInstances(BEFIG,LOFIG)
				befig_list *BEFIG;
				lofig_list *LOFIG;
{
C4_instance_list *new,*pt;
long tmp;
char *name;
lotrs_list *trans;
new = NULL;
new = C4_addInsFromName(new,C4_FICTIVE);
new = C4_addInsFromABL(new,BEFIG->BEOUT->ABL);
new = C4_addInsFromName(new,C4_FICTIVE);
pt = new;
while(pt!=NULL) {
				if (pt->NOM==namealloc(C4_FICTIVE)) {
								pt->GAUCHEP = NULL;
								pt->GAUCHEN = NULL;
								pt->DROITEN = NULL;
								pt->DROITEP = NULL;
				}
				else {
								name = malloc ((strlen(pt->NOM)+4)*sizeof (char));
								sprintf(name,"tn_%s",pt->NOM);
								trans = getlotrs(LOFIG,name);
								pt->GAUCHEN = trans->DRAIN->SIG;
								pt->DROITEN = trans->SOURCE->SIG;
								sprintf(name,"tp_%s",pt->NOM);
								trans = getlotrs(LOFIG,name);
								pt->GAUCHEP = trans->DRAIN->SIG;
								pt->DROITEP = trans->SOURCE->SIG;
								free(name);
				}
				pt = pt->NEXT;
}
pt = new;
while(pt!=NULL) {
				if (pt->NOM==namealloc(C4_FICTIVE)) if (pt->NEXT!=NULL) {pt->DROITEN = pt->NEXT->GAUCHEN;pt->DROITEP = pt->NEXT->GAUCHEP;}
				if (pt->NEXT!=NULL) if (pt->NEXT->NOM==namealloc(C4_FICTIVE)) {pt->NEXT->GAUCHEN = pt->DROITEN;pt->NEXT->GAUCHEP = pt->DROITEP;}
				pt = pt->NEXT;
}

pt = new;
tmp = new->INDEX;
while(pt!=NULL) {
				pt->INDEX = pt->INDEX-tmp;
				pt = pt->NEXT;
}
new->GAUCHEN = getlosig(LOFIG,1);
new->GAUCHEP = new->GAUCHEN;
return new;
}

/********************************************************
 * 							ADD VDD VSS 														*
 ********************************************************/

void addVddVss(FIG)
				C4_fig_route *FIG;
{
C4_instance_list *pt;
if (FIG==NULL) return;
pt = FIG->INS;
while(pt!=NULL) {
				if (pt->GAUCHEN->INDEX ==3) {pt->SIG[C4_NBTOT-1] = pt->GAUCHEN;pt->VIA[C4_NBTOT-1] = 1;}
				if (pt->GAUCHEP->INDEX ==2) {pt->SIG[0] = pt->GAUCHEP;pt->VIA[0] = 1;}
				pt = pt->NEXT;
}		
}

/********************************************************
 * 										RESET															*
 ********************************************************/

void resetFig(FIG)
				C4_fig_route *FIG;
{
C4_instance_list *pt;
int i;
if (FIG==NULL) return;
pt = FIG->INS;
while (pt!=NULL) {
				for(i=0;i<C4_NBTOT;i++) {
								pt->SIG[i]=NULL;
								pt->VIA[i]=0;
				}
				pt = pt->NEXT;
}
}

/********************************************************
 * 							PERMUTE OUT VSS VDD											*
 ********************************************************/

int notBufferName(NAME)
				char *NAME;
{
char *tmp; int i;
if (strlen(NAME)!=13) return 1;
tmp = malloc (7*sizeof(char));
for (i = 3; i<12; i++) tmp[i-3] = NAME[i];
if (strcmp(tmp, namealloc("c4_buffer"))) return 1;
//printf("BUFFER ! %s\n",NAME);
return 0;
}

void permuteOutVdd(FIG,LOFIG)
				C4_fig_route *FIG;
				lofig_list *LOFIG;
{
C4_instance_list *p;
losig_list *out,*vdd;
lotrs_list *t;
if (FIG==NULL) return;
out=getlosig(LOFIG,1);
vdd=getlosig(LOFIG,2);
t=LOFIG->LOTRS;
while(t!=NULL) {
				if ((t->TYPE==TRANSP) && (notBufferName(t->TRNAME))) {
								if (t->DRAIN->SIG==vdd) t->DRAIN->SIG = out;
								else if (t->DRAIN->SIG==out) t->DRAIN->SIG = vdd;
								if (t->SOURCE->SIG==vdd) t->SOURCE->SIG = out;
								else if (t->SOURCE->SIG==out) t->SOURCE->SIG = vdd;
				}
				t = t->NEXT;
}
p = FIG->INS;
while (p!=NULL) {
				if (p->GAUCHEP ==vdd) p->GAUCHEP = out;
				else if (p->GAUCHEP == out) p->GAUCHEP = vdd;
				if (p->DROITEP ==vdd) p->DROITEP = out;
				else if (p->DROITEP == out) p->DROITEP = vdd;
				p = p->NEXT;
}
FIG->INS->GAUCHEP = out;
}

void permuteOutVss(FIG,LOFIG)
				C4_fig_route *FIG;
				lofig_list *LOFIG;
{
C4_instance_list *p;
losig_list *out,*vss;
lotrs_list *t;
if (FIG==NULL) return;
out=getlosig(LOFIG,1);
vss=getlosig(LOFIG,3);
t=LOFIG->LOTRS;
while(t!=NULL) {
				if ((t->TYPE==TRANSN) && (notBufferName(t->TRNAME))) {
								if (t->DRAIN->SIG==vss) t->DRAIN->SIG = out;
								else if (t->DRAIN->SIG==out) t->DRAIN->SIG = vss;
								if (t->SOURCE->SIG==vss) t->SOURCE->SIG = out;
								else if (t->SOURCE->SIG==out) t->SOURCE->SIG = vss;
				}
				t = t->NEXT;
}
p = FIG->INS;
while (p!=NULL) {
				if (p->GAUCHEN ==vss) p->GAUCHEN = out;
				else if (p->GAUCHEN == out) p->GAUCHEN = vss;
				if (p->DROITEN ==vss) p->DROITEN = out;
				else if (p->DROITEN == out) p->DROITEN = vss;
				p = p->NEXT;
}
FIG->INS->GAUCHEN = out;
}

/********************************************************
 * 							ROUTE																		*
 ********************************************************/

C4_segment_list *newSeg(REF1,REF2,PLACE)
				C4_instance_list *REF1,*REF2;
				int PLACE;
{
C4_segment_list *new;
new = malloc(sizeof *new);
new->NEXT = NULL;
new->INDEX1 = PLACE;
new->INDEX2 = PLACE;
new->REF1 = REF1;
new->REF2 = REF2;
if (PLACE==C4_NBTOT) new->SIG = REF1->GAUCHEN;
else new->SIG = REF1->GAUCHEP;
new->TAILLE = REF2->INDEX-REF1->INDEX;
//printf("NewSig %d\n",new->SIG->INDEX);
return new;
}

C4_instance_list *getRightN(INS)
				C4_instance_list *INS;
{
C4_instance_list *r, *pt;
losig_list *sig;
pt = INS;
r = INS;
sig = INS->GAUCHEN;
while (pt!=NULL) {
				if (pt->GAUCHEN==sig) r = pt;
				pt =pt->NEXT;
}
return r;
}
C4_instance_list *getRightP(INS)
				C4_instance_list *INS;
{
C4_instance_list *r, *pt;
losig_list *sig;
pt = INS;
r = INS;
sig = INS->GAUCHEP;
while (pt!=NULL) {
				if (pt->GAUCHEP==sig) r = pt;
				pt =pt->NEXT;
}
return r;
}

C4_segment_list *addSeg(LIST,L,R,PLACE)
				C4_segment_list *LIST;
				C4_instance_list *L, *R;
				int PLACE;
{
C4_segment_list *new;
if (LIST ==NULL) return newSeg(L,R,PLACE);
if (L==R) return LIST;
if (((LIST->SIG == L->GAUCHEN)||(LIST->SIG == L->GAUCHEP) ) && (LIST->INDEX1==PLACE)) return LIST;
if (LIST->TAILLE<L->INDEX-R->INDEX) {
				new = newSeg(L,R,PLACE);
				new->NEXT = LIST;
				return new;
}
LIST->NEXT = addSeg(LIST->NEXT,L,R,PLACE);
return LIST;
}

C4_segment_list *genSeg(INS)
				C4_instance_list *INS;
{
C4_instance_list *pt;
C4_segment_list *seg;
if (INS==NULL) return NULL;
seg=NULL;
pt = INS;
while(pt!=NULL) {
				if (pt->GAUCHEN->INDEX!=3) seg=addSeg(seg,pt,getRightN(pt),C4_NBTOT);
			  if (pt->GAUCHEP->INDEX!=2) seg=addSeg(seg,pt,getRightP(pt),0);
				pt = pt->NEXT;
}
return seg;
}

int emptyLine(L,R,INDEX)
				C4_instance_list *L, *R;
				int INDEX;
{
if (L==NULL) return 0;
if (L==R) return 1;
if (L->SIG[INDEX]!=NULL) return 0;
return emptyLine(L->NEXT, R);
}

void placeSeg(SEG,INDEX)
				C4_segment_list *SEG;
				int INDEX;
{
C4_instance_list *pt;
if (SEG==NULL) return;
pt = SEG->REF1;
SEG->INDEX1 = INDEX;
SEG->INDEX2 = INDEX;
while(pt!=NULL) {
				pt->SIG[INDEX] = SEG->SIG;
				if (INDEX<C4_NBP) {if (pt->GAUCHEP==SEG->SIG) pt->VIA[INDEX] = 1;}
				else {if (pt->GAUCHEN==SEG->SIG) pt->VIA[INDEX] = 1;}
				if (pt==SEG->REF2) pt=NULL;
				else pt = pt->NEXT;
}
}

int routeSeg(SEG)
				C4_segment_list *SEG;
{
int l,place;
place = 0;
if (SEG==NULL) return 1;
if (SEG->INDEX1==0) {
				for (l=1;l<C4_NBP;l++)
								if (emptyLine(SEG->REF1,SEG->REF2,l)) {placeSeg(SEG,l); l = C4_NBTOT; place = 1;}
				}
else for (l=C4_NBTOT-2;l>C4_NBTOT-C4_NBN-1;l--)
								if (emptyLine(SEG->REF1,SEG->REF2,l)) {placeSeg(SEG,l); l = 0; place = 1;}
if (place==0) return 0;
return routeSeg(SEG->NEXT);
}

int C4_route(FIG,LOFIG)
				C4_fig_route *FIG;
				lofig_list *LOFIG;
{
int route,i;
if (FIG==NULL) return 0;
if (FIG->INS==NULL) return 0;
FIG->SEG = genSeg(FIG->INS);
addVddVss(FIG);
route=routeSeg(FIG->SEG);
for (i=0;i<C4_NBTOT; i++) {FIG->INS->VIA[i]=0;/*FIG->INS->SIG[i]=NULL;*/}
return route;
}

/********************************************************
 * 										REVERSE														*
 ********************************************************/

C4_instance_list *reverseIns(INS)
				C4_instance_list *INS;
{
C4_instance_list *new,*tmp,*next;
if (INS==NULL) return NULL;
tmp =INS;
next =NULL;
while (tmp!=NULL) {
	new = newIns(tmp->NOM);
	new->GAUCHEN = tmp->DROITEN;
	new->GAUCHEP = tmp->DROITEP;
	new->DROITEN = tmp->GAUCHEN;
	new->DROITEP = tmp->GAUCHEP;
	if (next!=NULL) new->INDEX = next->INDEX-1;
	else {new->DROITEN=NULL; new->DROITEP=NULL;}
	new->NEXT = next;
	next = new;
	tmp = tmp->NEXT;
}
return new;
}

C4_fig_route *reverseFig(FIG,LOFIG)
				C4_fig_route *FIG;
				lofig_list *LOFIG;
{
C4_fig_route *new;
C4_instance_list *pt;
if (FIG==NULL) return NULL;
new = malloc(sizeof *new);
new->INS = reverseIns(FIG->INS);
pt = new->INS->NEXT;
while(pt!=NULL) {
				pt->INDEX = pt->INDEX-new->INS->INDEX;
				pt = pt->NEXT;
}
new->INS->INDEX = 0;
new->INS->GAUCHEN = getlosig(LOFIG,1);
new->INS->GAUCHEP = new->INS->GAUCHEN;
new->SEG = genSeg(new->INS);
new->NOM = FIG->NOM;
new->SORTIE = FIG->SORTIE;
return new;
}

/********************************************************
 * 										TOPOLOGIE													*
 ********************************************************/

C4_fig_route *C4_topologie (LOFIG,BEFIG)
				lofig_list *LOFIG;
				befig_list *BEFIG;
{
C4_instance_list *TOPO;
C4_fig_route *C4FIG;
int route;
TOPO = C4_placeInstances(BEFIG,LOFIG);
C4FIG = malloc(sizeof *C4FIG);
C4FIG->NOM = LOFIG->NAME;
C4FIG->INS = TOPO;
C4FIG->SORTIE = getsigname(getlosig(LOFIG,1));
C4FIG->SEG=NULL;
//C4FIG->INS->INDEX=0;
route = C4_route(C4FIG,LOFIG);
//C4_aff_fig(C4FIG);
if (route==1) return C4FIG;
resetFig(C4FIG);
permuteOutVdd(C4FIG);
route = C4_route(C4FIG,LOFIG);
if (route==1) return C4FIG;
resetFig(C4FIG);
permuteOutVss(C4FIG);
route = C4_route(C4FIG,LOFIG);
if (route==1) return C4FIG;
resetFig(C4FIG);
permuteOutVdd(C4FIG);
route = C4_route(C4FIG,LOFIG);
if (route==1) return C4FIG;

C4FIG=reverseFig(C4FIG,LOFIG);
route = C4_route(C4FIG,LOFIG);
if (route==1) return C4FIG;
resetFig(C4FIG);
permuteOutVdd(C4FIG);
route = C4_route(C4FIG,LOFIG);
if (route==1) return C4FIG;
resetFig(C4FIG);
permuteOutVss(C4FIG);
route = C4_route(C4FIG,LOFIG);
if (route==1) return C4FIG;
resetFig(C4FIG);
permuteOutVdd(C4FIG);
route = C4_route(C4FIG,LOFIG);
if (route==1) return C4FIG;
return NULL;
}
