#ifndef __C4_topologie_H__
#define __C4_topologie_H__

/*------------------------------------------------------------\
|                                                             |
| This file is part of the Alliance CAD System Copyright      |
| (C) Laboratoire LIP6 - Dpartement ASIM Universite P&M Curie|
|                                                             |
| Home page      : http://www-asim.lip6.fr/alliance/          |
| E-mail support : mailto:alliance-support@asim.lip6.fr       |
|                                                             |
| This progam is  free software; you can redistribute it      |
| and/or modify it under the  terms of the GNU Library General|
| Public License as published by the Free Software Foundation |
| either version 2 of the License, or (at your option) any    |
| later version.                                              |
|                                                             |
| Alliance VLSI  CAD System  is distributed  in the hope that |
| it  will be useful, but WITHOUT  ANY WARRANTY;              |
| without even the  implied warranty of MERCHANTABILITY or    |
| FITNESS FOR A PARTICULAR PURPOSE. See the GNU General       |
| Public License for more details.                            |
|                                                             |
| You should have received a copy  of the GNU General Public  |
| License along with the GNU C Library; see the file COPYING. |
| If not, write to the Free Software Foundation, Inc.,        |
| 675 Mass Ave, Cambridge, MA 02139, USA.                     |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------\
|                                                       |
|  Title   :            C4_topologie										|
|                                                       |
|  Date    :              30.10.01                      |
|                                                       |
|  Authors :  Greiner Alain, Beaudenon Vincent          |
|                                                       |
\------------------------------------------------------*/

#ifndef C4_FICTIVE
#define C4_FICTIVE "*"
#endif

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include MUT_H
#include AUT_H
#include ABL_H
#include BDD_H
#include ABE_H
#include ABV_H
#include ABT_H

#include MLO_H
#include MLU_H
#include MPH_H

#define C4_NBN 4
#define C4_NBP 4
#define C4_NBTOT 9

typedef struct C4_instance
{
				struct C4_instance *NEXT;
				char *NOM;
				losig_list *GAUCHEN;
				losig_list *GAUCHEP;
				losig_list *DROITEN;
				losig_list *DROITEP;
				losig_list *SIG[C4_NBTOT];
				int VIA[C4_NBTOT];
				long INDEX;
//				int INDEX;
}
C4_instance_list;

typedef struct C4_segment
{
				struct C4_segment *NEXT;
				C4_instance_list *REF1;
				C4_instance_list *REF2;
				int INDEX1;
				int INDEX2;
				losig_list *SIG;
				long TAILLE;
//				int TAILLE;
}
C4_segment_list;

typedef struct C4_fig
{
				C4_instance_list *INS;
				C4_segment_list *SEG;
				char *NOM;
				char *SORTIE;
}
C4_fig_route;

void C4_aff_fig (C4_fig_route *);
C4_fig_route *reverseFig(C4_fig_route *,lofig_list *);
C4_fig_route *C4_topologie(lofig_list *, befig_list *);

#endif
