/*------------------------------------------------------------\
|                                                             |
| This file is part of the Alliance CAD System Copyright      |
| (C) Laboratoire LIP6 - Dpartement ASIM Universite P&M Curie|
|                                                             |
| Home page      : http://www-asim.lip6.fr/alliance/          |
| E-mail support : mailto:alliance-support@asim.lip6.fr       |
|                                                             |
| This progam is  free software; you can redistribute it      |
| and/or modify it under the  terms of the GNU Library General|
| Public License as published by the Free Software Foundation |
| either version 2 of the License, or (at your option) any    |
| later version.                                              |
|                                                             |
| Alliance VLSI  CAD System  is distributed  in the hope that |
| it  will be useful, but WITHOUT  ANY WARRANTY;              |
| without even the  implied warranty of MERCHANTABILITY or    |
| FITNESS FOR A PARTICULAR PURPOSE. See the GNU General       |
| Public License for more details.                            |
|                                                             |
| You should have received a copy  of the GNU General Public  |
| License along with the GNU C Library; see the file COPYING. |
| If not, write to the Free Software Foundation, Inc.,        |
| 675 Mass Ave, Cambridge, MA 02139, USA.                     |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------\
|                                                       |
|  Title   :            Delay (c4map) 									|
|                                                       |
|  Date    :             30.10.01                       |
|                                                       |
|  Authors :         Beaudenon Vincent                  |
|                                                       |
\------------------------------------------------------*/

#include "delay.h"

int getTransmitters(NODE)
				c_node_list *NODE;
{
int n;
c_link_list *ptr;
ptr = NODE->PRED;
n = 0;
while (ptr!=NULL) {n++; ptr = ptr->PRED;}
if ((n%2)!=0) {printf("Erreur sur les metteurs de %s\n",NODE->SIGNAME); exit (-1);}
return n/2;
}

void getBusDelay (NODE)
				c_node_list *NODE;
{
c_link_list *ptr;
int n;
double ud ,uc, dd, dc, maxu, maxd, tuud, tuuc, tduc, tddd, tddc, tudc;
n = getTransmitters(NODE);
tuud = n * C_TBUUD;
tuuc = n * C_TBUUC;
tduc = n * C_TBDUC;
tddd = n * C_TBDDD;
tddc = n * C_TBDDC;
tudc = n * C_TBUDC;
ud = 0;
uc = 0;
dd = 0;
dc = 0;
ptr = NODE->PRED;
while (ptr!=NULL) {
				if (ptr->SOURCE==NULL) {printf("Erreur sur la source de %s\n",ptr->SIGNAME); exit (-1);}
				if (ptr->SOURCE->U>ud) ud = ptr->SOURCE->U;
				if (ptr->SOURCE->D>dd) dd = ptr->SOURCE->D;
				if (ptr->PRED->SOURCE->U>uc) uc = ptr->PRED->SOURCE->U;
				if (ptr->PRED->SOURCE->D>dc) dc = ptr->PRED->SOURCE->D;
				ptr = ptr->PRED->PRED;
}
maxu = ud+tuud;
if ((uc+tuuc)>maxu) maxu = uc+tuuc;
if ((dc+tduc)>maxu) maxu = dc+tduc;
maxd = dd+tddd;
if ((dc+tddc)>maxd) maxd = dc+tddc;
if ((uc+tudc)>maxd) maxd = uc+tudc;
NODE->D = maxd;
NODE->U = maxu;
}
