/*------------------------------------------------------------\
|                                                             |
| This file is part of the Alliance CAD System Copyright      |
| (C) Laboratoire LIP6 - Dpartement ASIM Universite P&M Curie|
|                                                             |
| Home page      : http://www-asim.lip6.fr/alliance/          |
| E-mail support : mailto:alliance-support@asim.lip6.fr       |
|                                                             |
| This progam is  free software; you can redistribute it      |
| and/or modify it under the  terms of the GNU Library General|
| Public License as published by the Free Software Foundation |
| either version 2 of the License, or (at your option) any    |
| later version.                                              |
|                                                             |
| Alliance VLSI  CAD System  is distributed  in the hope that |
| it  will be useful, but WITHOUT  ANY WARRANTY;              |
| without even the  implied warranty of MERCHANTABILITY or    |
| FITNESS FOR A PARTICULAR PURPOSE. See the GNU General       |
| Public License for more details.                            |
|                                                             |
| You should have received a copy  of the GNU General Public  |
| License along with the GNU C Library; see the file COPYING. |
| If not, write to the Free Software Foundation, Inc.,        |
| 675 Mass Ave, Cambridge, MA 02139, USA.                     |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------\
|                                                       |
|  Title   :            Fig  (c4map)  									|
|                                                       |
|  Date    :             30.10.01                       |
|                                                       |
|  Authors :  Greiner Alain, Beaudenon Vincent          |
|                                                       |
\------------------------------------------------------*/
#include "fig.h"

void
showFig (FIG)
     c_fig_list *FIG;
{
//  c_link_list *ptr;
	if (FIG == NULL)
    return;
  printf ("C4MAP FIGURE : %s\n", FIG->FIGNAME);
  showNode (FIG->NODELIST);
//	ptr = FIG->LINKLIST;
//	while(ptr!=NULL) {printf("-- ");showLinkSp(ptr,0); ptr = ptr->SUCC;}
	showFig (FIG->NEXT);
}

c_fig_list *
genFig (BEFIG)
     befig_list *BEFIG;
{
  c_fig_list *new;
  if (BEFIG == NULL)
    return NULL;
  new = malloc (sizeof *new);
  new->NODELIST = genNodeFromBefig (BEFIG);
  genDAGFromNode (new->NODELIST);
//	showNode(new->NODELIST);
	new->NODELIST = removeUnaryNodes(new->NODELIST);
  new->FIGNAME = namealloc (BEFIG->NAME);
  new->LINKLIST = NULL;
  new->NEXT = NULL;
  return new;
}

void
optimFig (FIG, NMAX, PMAX)
     c_fig_list *FIG;
     int NMAX;
     int PMAX;
{
  if (FIG == NULL)
    return;
  optimNodeList (FIG->NODELIST, NMAX, PMAX);
}

void
restructFig (FIG)
     c_fig_list *FIG;
{
  if (FIG == NULL)
    return;
  FIG->LINKLIST = restructNodeList (FIG->NODELIST);
  setSucc (FIG->LINKLIST);
}

void
optimInverters (FIG)
     c_fig_list *FIG;
{
  if (FIG == NULL)
    return;
  optimInv (FIG->NODELIST);
  setInverters (FIG->NODELIST);
//addInverters(FIG->LINKLIST);
}

lofig_list *genLofigFromFig(FIG)
				c_fig_list *FIG;
{
c_node_list *ptr;
losig_list *vdd, *vss;
lofig_list *models, *new;
FILE *file;
c_link_list *link;
//for (link = FIG->LINKLIST; link!=NULL; link = link->SUCC) showLinkSp(link,5);
if (FIG==NULL) {printf("NO FIG\n"); exit (-1);}
file = fopen ("CATAL","w");
fprintf(file,"powmid_x0 C\npowmid_x0 F\nrowend_x0 C\nrowend_x0 F\ntie_x0 C\ntie_x0 F");
fprintf(file,"\n%s C\n%s C\n%s C\n%s C\n%s C",C_INV_CELL,C_REG_CELL,C_BUS_CELL,C_NXOR_CELL,C_XOR_CELL);
new = addlofig (FIG->FIGNAME);
vdd = addlosig(new,1,addchain(NULL,namealloc("vdd")),EXTERNAL);
vss = addlosig(new,2,addchain(NULL,namealloc("vss")),EXTERNAL);
ptr = searchNode("vdd",FIG->NODELIST);
ptr->OUTSIG=vdd;
ptr = searchNode("vss",FIG->NODELIST);
ptr->OUTSIG=vss;
genSigList(new,FIG->LINKLIST);
models=NULL;
ptr = FIG->NODELIST;
  while (ptr != NULL)
    {
      /*models = */addModelFromNode (ptr/*, models*/,file);
      ptr = ptr->NEXT;
    }
ptr = FIG->NODELIST;
fclose (file);
while (ptr !=NULL)
	{
		addInstanceFromNode (ptr, new,vdd,vss);
		ptr = ptr->NEXT;
	}
savelofig(new);

return models;
}
