/*------------------------------------------------------------\
|                                                             |
| This file is part of the Alliance CAD System Copyright      |
| (C) Laboratoire LIP6 - Dpartement ASIM Universite P&M Curie|
|                                                             |
| Home page      : http://www-asim.lip6.fr/alliance/          |
| E-mail support : mailto:alliance-support@asim.lip6.fr       |
|                                                             |
| This progam is  free software; you can redistribute it      |
| and/or modify it under the  terms of the GNU Library General|
| Public License as published by the Free Software Foundation |
| either version 2 of the License, or (at your option) any    |
| later version.                                              |
|                                                             |
| Alliance VLSI  CAD System  is distributed  in the hope that |
| it  will be useful, but WITHOUT  ANY WARRANTY;              |
| without even the  implied warranty of MERCHANTABILITY or    |
| FITNESS FOR A PARTICULAR PURPOSE. See the GNU General       |
| Public License for more details.                            |
|                                                             |
| You should have received a copy  of the GNU General Public  |
| License along with the GNU C Library; see the file COPYING. |
| If not, write to the Free Software Foundation, Inc.,        |
| 675 Mass Ave, Cambridge, MA 02139, USA.                     |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------\
|                                                       |
|  Title   :            Link (c4map) 					    			|
|                                                       |
|  Date    :             30.10.01                       |
|                                                       |
|  Authors :  Greiner Alain, Beaudenon Vincent          |
|                                                       |
\------------------------------------------------------*/
#include "link.h"

void
showLinkSp (LINK, S)
     c_link_list *LINK;
     int S;
{
  int i;
  if (LINK == NULL)
    return;
  for (i = 0; i < S; i++)
    printf (" ");
  if (LINK->SIGNAME == NULL)
    {
      printf ("SIGNAME = NULL\n");
      return;
    }
  if (LINK->SOURCE == NULL)
    {
      printf ("SOURCE = NULL\n");
      return;
    }
  if (LINK->DEST == NULL)
    {
      printf ("OUTPUT SIGNAL %s",LINK->SOURCE->SIGNAME);
    }

//  if (LINK->DEST->SIGNAME == /*namealloc (NULL)*/NULL)
//    {
//      printf ("DEST NAME = NULL\n");
//      return;
//    }
//  if (LINK->SOURCE->SIGNAME == /*namealloc (NULL)*/NULL)
//    {
//      printf ("SOURCE NAME = NULL\n");
//      return;
//    }
	else  printf ("Sig :%s Source : %s Inv:%d %d/%d Dest:%s", LINK->SIGNAME,
	  LINK->SOURCE->SIGNAME, LINK->INV, LINK->NINV, LINK->NTOT,
	  LINK->DEST->SIGNAME);
	if (LINK->SIG==NULL) printf("\n"); else printf (" %d %s\n",LINK->SIG->INDEX,LINK->SIG->NAMECHAIN->DATA);
//  showLinkSp (LINK->PRED, S);
}

//******************* GEN *****************

c_link_list *
genLinkFromName (NAME)
     char *NAME;
{
  c_link_list *new;
  if (NAME == NULL)
    return NULL;
//	printf("GENLINK %s\n",NAME);
  new = malloc (sizeof *new);
  new->PRED = NULL;
  new->SUCC = NULL;
  new->SIGNAME = namealloc (NAME);
  new->INV = 0;
  new->NINV = 0;
  new->NTOT = 0;
  new->SOURCE = NULL;
  new->DEST = NULL;
  new->SIG = NULL;
  return new;
}

//********************* SUCC LIST **************

c_link_list *
addSuccList (LIST, ELEM)
     c_link_list *LIST;
     c_link_list *ELEM;
{
//printf("ADD SUCC\n");
//showLinkSp(ELEM,5);
  if (ELEM == NULL)
    return LIST;
  if (LIST == NULL)
    {
      ELEM->NTOT = 1;
      ELEM->NINV = ELEM->INV;
      return ELEM;
    }
  if (strcmp (ELEM->SOURCE->SIGNAME, LIST->SOURCE->SIGNAME) < 0)
    {
      LIST->SUCC = addSuccList (LIST->SUCC, ELEM);
      return LIST;
    }
  if (strcmp (ELEM->SOURCE->SIGNAME, LIST->SOURCE->SIGNAME) > 0)
    {
      ELEM->NTOT = 1;
      ELEM->NINV = ELEM->INV;
      ELEM->SUCC = LIST;
      return ELEM;
    }
  ELEM->NTOT = LIST->NTOT + 1;
  ELEM->NINV = LIST->NINV + ELEM->INV;
  ELEM->SUCC = LIST;
  return ELEM;
}

c_link_list *
addPredList (LIST, ELEM)
     c_link_list *LIST;
     c_link_list *ELEM;
{
  if (ELEM == NULL)
    return LIST;
  if (LIST == NULL)
    {
      ELEM->PRED = NULL;
      return ELEM;
    }
  ELEM->PRED = LIST;
  return ELEM;
}

void
addPredFromTree (TREE)
     c_tree_list *TREE;
{
  if (TREE == NULL)
    return;
  if (TREE->VAR != NULL)
    {
//                              printf("ADDPRE\n");
//                              showLinkSp(TREE->VAR,5);
      TREE->VAR->DEST->PRED = addPredList (TREE->VAR->DEST->PRED, TREE->VAR);
//                              showLinkSp(TREE->VAR,5);                                
    }
  addPredFromTree (TREE->SUP);
  addPredFromTree (TREE->NEXT);
}


void
genPredList (NODE)
     c_node_list *NODE;
{
  if (NODE == NULL)
    return;
  if (NODE->TREE == NULL)
    return;
//NODE->PRED=NULL;
  addPredFromTree (NODE->TREE);
}

c_link_list *
searchFirstSucc (LIST, NAME)
     c_link_list *LIST;
     char *NAME;
{
  c_link_list *ptr;
  ptr = LIST;
  while (ptr != NULL)
    {
      if (ptr->SOURCE->SIGNAME == NAME)
	return ptr;
      ptr = ptr->SUCC;
    }
  return NULL;
}

void
setSucc (LINK)
     c_link_list *LINK;
{
  c_link_list *ptr;
  char *name;
  if (LINK == NULL)
    return;
  name = NULL;
  ptr = LINK;
  while (ptr != NULL)
    {
      if (ptr->SOURCE->SIGNAME != name)
	{
	  ptr->SOURCE->SUCC = ptr;
	  name = ptr->SOURCE->SIGNAME;
	}
      ptr = ptr->SUCC;
    }
}

// ****************************** ADD INVERTERS ****************************

void
genInverter (LINK)
     c_link_list *LINK;
{
  c_node_list *node;
  c_link_list *link;
  char *name;
  if (LINK == NULL)
    return;
  node = malloc (sizeof *node);
  name = malloc ((strlen (LINK->SOURCE->SIGNAME) + 3) * sizeof (char));
  sprintf (name, "%s_n", LINK->SOURCE->SIGNAME);
  link = genLinkFromName (name);
  node->NEXT = LINK->SOURCE->NEXT;
  LINK->SOURCE->NEXT = node;
  node->SIGNAME = namealloc (name);
  node->TYPE_FONC = INV_NODE;
  node->INV = 0;
  node->TREE = NULL;
  node->U = LINK->SOURCE->U + C_TINV;
  node->D = LINK->SOURCE->D + C_TINV;
  node->PRED = LINK;
  node->SUCC = link;
  node->LOFIG = NULL;
  LINK->DEST = node;
}

void
addInverters (LINKLIST)
     c_link_list *LINKLIST;
{
  c_link_list *ptr;
  ptr = LINKLIST;
  while (ptr != NULL)
    {
      if (ptr->INV == 1)
	genInverter (ptr);
      ptr = ptr->SUCC;
    }
}
