/*------------------------------------------------------------\
|                                                             |
| This file is part of the Alliance CAD System Copyright      |
| (C) Laboratoire LIP6 - Dpartement ASIM Universite P&M Curie|
|                                                             |
| Home page      : http://www-asim.lip6.fr/alliance/          |
| E-mail support : mailto:alliance-support@asim.lip6.fr       |
|                                                             |
| This progam is  free software; you can redistribute it      |
| and/or modify it under the  terms of the GNU Library General|
| Public License as published by the Free Software Foundation |
| either version 2 of the License, or (at your option) any    |
| later version.                                              |
|                                                             |
| Alliance VLSI  CAD System  is distributed  in the hope that |
| it  will be useful, but WITHOUT  ANY WARRANTY;              |
| without even the  implied warranty of MERCHANTABILITY or    |
| FITNESS FOR A PARTICULAR PURPOSE. See the GNU General       |
| Public License for more details.                            |
|                                                             |
| You should have received a copy  of the GNU General Public  |
| License along with the GNU C Library; see the file COPYING. |
| If not, write to the Free Software Foundation, Inc.,        |
| 675 Mass Ave, Cambridge, MA 02139, USA.                     |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------\
|                                                       |
|  Title   :            Link (c4map)  									|
|                                                       |
|  Date    :             30.10.01                       |
|                                                       |
|  Authors : Greiner Alain, Beaudenon Vincent           |
|                                                       |
\------------------------------------------------------*/
#ifndef __C_LINK_H__
#define __C_LINK_H__

#include <stdio.h>
#include <stdlib.h>

#include "node.h"

typedef struct c_link
{
  struct c_link *PRED;
  struct c_link *SUCC;
  char *SIGNAME;
  char INV;
  int NINV;
  int NTOT;
  struct c_node *SOURCE;
  struct c_node *DEST;
  losig_list *SIG;
}
c_link_list;

void showLinkSp (c_link_list *, int);
c_link_list *genLinkFromName (char *);

c_link_list *addSuccList (c_link_list *, c_link_list *);
c_link_list *searchFirstSucc (c_link_list *, char *);
c_link_list *addPredList (c_link_list *, c_link_list *);
void genPredList (struct c_node *);
void setSucc (c_link_list *);
void addInverters (c_link_list *);
#endif
