/*------------------------------------------------------------\
|                                                             |
| This file is part of the Alliance CAD System Copyright      |
| (C) Laboratoire LIP6 - Dpartement ASIM Universite P&M Curie|
|                                                             |
| Home page      : http://www-asim.lip6.fr/alliance/          |
| E-mail support : mailto:alliance-support@asim.lip6.fr       |
|                                                             |
| This progam is  free software; you can redistribute it      |
| and/or modify it under the  terms of the GNU Library General|
| Public License as published by the Free Software Foundation |
| either version 2 of the License, or (at your option) any    |
| later version.                                              |
|                                                             |
| Alliance VLSI  CAD System  is distributed  in the hope that |
| it  will be useful, but WITHOUT  ANY WARRANTY;              |
| without even the  implied warranty of MERCHANTABILITY or    |
| FITNESS FOR A PARTICULAR PURPOSE. See the GNU General       |
| Public License for more details.                            |
|                                                             |
| You should have received a copy  of the GNU General Public  |
| License along with the GNU C Library; see the file COPYING. |
| If not, write to the Free Software Foundation, Inc.,        |
| 675 Mass Ave, Cambridge, MA 02139, USA.                     |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------\
|                                                       |
|  Title   :            Lofig (c4map) 									|
|                                                       |
|  Date    :             30.10.01                       |
|                                                       |
|  Authors :  Greiner Alain, Beaudenon Vincent          |
|                                                       |
\------------------------------------------------------*/
#include "lofig.h"

losig_list *getSigFromPred(PRED,NAME)
				c_link_list *PRED;
				char *NAME;
{
c_link_list *ptr;
ptr = PRED;
while (ptr!=NULL) {
				if (namealloc(ptr->SIGNAME)==namealloc(NAME)) return ptr->SIG;
				ptr = ptr->PRED;
}
return NULL;
}

chain_list *getPortList (CON,PRED,SIGOUT,VDD,VSS)
				locon_list *CON;
				c_link_list *PRED;
				losig_list *SIGOUT;
				losig_list *VDD;
				losig_list *VSS;
{
chain_list *new;
locon_list *ptr;
losig_list *sig;
new = NULL;
ptr = CON;
while (ptr!=NULL) {
/*				if (ptr->DIRECTION == OUT) sig = SIGOUT;
				else if (namealloc(ptr->NAME)==namealloc("vss")) sig = VSS;
				else if (namealloc(ptr->NAME)==namealloc("vdd")) sig = VDD;
				else sig = getSigFromPred(PRED,ptr->NAME);*/
			  if (namealloc(ptr->NAME)==namealloc("vss")) sig = VSS;
				else if (namealloc(ptr->NAME)==namealloc("vdd")) sig = VDD;
				else sig = getSigFromPred(PRED,ptr->NAME);
				if (sig==NULL) sig = SIGOUT; //{printf("Pas de lien %s sur sur le noeud %s\n",ptr->NAME,PRED->DEST->SIGNAME); exit(-1);}
				new = addchain(new, sig);
				ptr = ptr->NEXT;
}
return reverse(new);
}

void addInNode(NODE,LOFIG)
				c_node_list *NODE;
				lofig_list *LOFIG;
{
locon_list *locon = addlocon(LOFIG,NODE->SIGNAME,NODE->OUTSIG,IN);
				if (locon==NULL) {printf("Pas de connecteur pour le noeud %s\n", NODE->SIGNAME); exit(-1);}
				if (NODE->OUTSIG==NULL){printf("Pas de sigout pour le noeud %s\n", NODE->SIGNAME); exit(-1);}
}

void addOutNode(NODE,LOFIG)
				c_node_list *NODE;
				lofig_list *LOFIG;
{
addlocon(LOFIG,NODE->SIGNAME,NODE->OUTSIG,OUT);
}

void addBusNode(NODE,LOFIG,VDD,VSS)
				c_node_list *NODE;
				lofig_list *LOFIG;
				losig_list *VDD;
				losig_list *VSS;
{
long size;
c_link_list *pred;
char *name;
pred = NODE->PRED;
size =0;
while (pred!=NULL) {
	size = size+1;
				if (pred->PRED!=NULL) pred=pred->PRED->PRED;
				else {printf ("Problme de liens sur le noeud %s\n",NODE->SIGNAME); exit (-1);}
}
//printf("Noeud %s Size = %d\n", NODE->SIGNAME,size);
if (size == 1) addloins (LOFIG,NODE->SIGNAME,NODE->LOFIG,getPortList(NODE->LOFIG->LOCON,NODE->PRED,NODE->OUTSIG,VDD,VSS));
else {
				pred = NODE->PRED;
				name = malloc (sizeof(char)*(strlen(C_PREFIXE)+strlen(NODE->SIGNAME)+getSize(size)+2));
while (pred!=NULL) {
				sprintf(name,"%s%s%x_",C_PREFIXE,NODE->SIGNAME,size);
				size--;
				addloins(LOFIG,namealloc(name),NODE->LOFIG,getPortList(NODE->LOFIG->LOCON,pred,NODE->OUTSIG,VDD,VSS));
				if (pred->PRED!=NULL) pred=pred->PRED->PRED;
				else {printf ("Problme de liens sur le noeud %s\n",NODE->SIGNAME); exit (-1);}
}
free(name);
}
}

void addRegNode(NODE,LOFIG,VDD,VSS)
				c_node_list *NODE;
				lofig_list *LOFIG;
				losig_list *VDD;
				losig_list *VSS;
{
addloins(LOFIG,NODE->SIGNAME,NODE->LOFIG,getPortList(NODE->LOFIG->LOCON,NODE->PRED,NODE->OUTSIG,VDD,VSS));
}

void addC4Node(NODE,LOFIG,VDD,VSS)
				c_node_list *NODE;
				lofig_list *LOFIG;
				losig_list *VDD;
				losig_list *VSS;
{
if (NODE->LOFIG==NULL) return;
addloins(LOFIG,NODE->SIGNAME,NODE->LOFIG,getPortList(NODE->LOFIG->LOCON,NODE->PRED,NODE->OUTSIG,VDD,VSS));
}


void addInstanceFromNode (NODE,LOFIG,VDD,VSS)
				c_node_list *NODE;
				lofig_list *LOFIG;
				losig_list *VDD;
				losig_list *VSS;
{
if (NODE==NULL) return;
if (LOFIG==NULL) return;
//printf("Noeud %s\n",NODE->SIGNAME);
if ((NODE->TYPE_TOPO==IN_NODE) && (NODE->TYPE_FONC!=REG_NODE)) {addInNode(NODE,LOFIG); return;}
if (NODE->TYPE_TOPO==IN_NODE) return;
if ((NODE->TYPE_TOPO==OUT_NODE) && (NODE->TYPE_FONC!=REG_NODE)) addOutNode(NODE,LOFIG);
if (NODE->TYPE_FONC==BUS_NODE) addBusNode(NODE,LOFIG,VDD,VSS);
if (NODE->TYPE_FONC==REG_NODE) addRegNode(NODE,LOFIG,VDD,VSS);
if (NODE->TYPE_FONC==C4_NODE) addC4Node(NODE,LOFIG,VDD,VSS);
}

//lofig_list *
void addModelFromNode (NODE/*, MODELS*/,file)
     c_node_list *NODE;
		 FILE *file;
//     lofig_list *MODELS;
{
  lofig_list *model;
  char *gname;
  if (NODE == NULL)
    return ;//MODELS;
//if (MODELS==NULL) return MODELS;
//  if (NODE->TREE == NULL)
//    return MODELS;
	if (NODE->TYPE_TOPO==IN_NODE) return ;//MODELS;
	if (NODE->TYPE_FONC==BUS_NODE)
		gname = namealloc (C_BUS_CELL);
	else if (NODE->TYPE_FONC==REG_NODE) 
		gname = namealloc (C_REG_CELL);
	else if (NODE->TYPE_FONC == XOR_NODE)
    gname = namealloc (C_XOR_CELL);
  else if (NODE->TYPE_FONC == NXOR_NODE)
    gname = namealloc (C_NXOR_CELL);
  else if (NODE->TYPE_FONC == INV_NODE)
    gname = namealloc (C_INV_CELL);
  else
    gname = namealloc (NODE->TREE->GNAME);
	if (gname==namealloc("")) {
					//printf ("NODE : %s \n",NODE->SIGNAME);
					NODE->OUTSIG = NODE->PRED->SIG;
					return;
	}
	for (model=HEAD_LOFIG; model !=NULL; model = model->NEXT) if (namealloc(model->NAME)==gname) break;
	if (model == NULL) {if ((NODE->TYPE_FONC==C4_NODE)) C4_main (genBefigFromNode (NODE), gname, 1, 1, 0, 1, 1);
					fprintf(file,"\n%s C",gname);
	}
	NODE->LOFIG = getlofig(gname,'A');	
/*	model = getlomodel (MODELS, gname);
	if (model == NULL) {
		if ((NODE->TYPE_FONC==C4_NODE)) C4_main (genBefigFromNode (NODE), gname, 1, 1, 0, 0, 0);
		for (model=HEAD_LOFIG; model != NULL; model =  model->NEXT) if (namealloc (model->NAME) == gname) break;
		if (model==NULL) {model = addlofig(gname);//		loadlofig(model,gname,'A');}
		MODELS = addlomodel (MODELS,gname);
	}
		loadlofig(model,gname,'A');}
NODE->LOFIG = model;
  return MODELS;*/
}

void
addNodeInLofig (NODE, LOFIG)
     c_node_list *NODE;
     lofig_list *LOFIG;
{
}

void genSigList(LOFIG,LINKLIST)
				lofig_list *LOFIG;
				c_link_list *LINKLIST;

{
char *name, *signame;
c_link_list *ptr;
int s,n; long index;
losig_list *sig, *not;
char type;
c_node_list *node;
ptr = LINKLIST;
s=0; n = 0; index=3;
name =NULL;
while (ptr !=NULL) {
				if (ptr->SOURCE->SIGNAME!=name) {
								s=0;
								n=0;
								name = ptr->SOURCE->SIGNAME;}
					//			if (namealloc(name)==namealloc("cout")) printf ("GENSIG :%s\n",name);
								if (((ptr->SOURCE->TYPE_TOPO==IN_NODE) && (ptr->SOURCE->TYPE_FONC!=REG_NODE)) || ((ptr->SOURCE->TYPE_TOPO==OUT_NODE)&&(ptr->SOURCE->TYPE_FONC!=REG_NODE))) type = EXTERNAL; else type = INTERNAL;
								if (ptr->INV == 0) {
												if (s==0) {
													sig = addlosig(LOFIG, index,addchain(NULL,ptr->SOURCE->SIGNAME),type);
													s = 1;
													index++;
												}
													ptr->SIG=sig;
													ptr->SOURCE->OUTSIG = sig;
												
								}
								else {
												if (n==0){
														if (s==0) {
													sig = addlosig(LOFIG, index,addchain(NULL,ptr->SOURCE->SIGNAME),type);
													s = 1;
													index++;
												}
													signame = malloc ((strlen (ptr->SOURCE->SIGNAME) +5) * sizeof (char));
													sprintf(signame,"not_%s",ptr->SOURCE->SIGNAME);
											//		printf("AJOUT SIGNAL INVERSEUR : "); showLinkSp(ptr,0);
													not = addlosig(LOFIG,index,addchain(NULL,namealloc(signame)), INTERNAL);
													n=1;
													index++;
													node = genNodeFromName(signame);
													node->TYPE_TOPO=AUX_NODE;
													node->TYPE_FONC = INV_NODE;
													node->OUTSIG = not;
													node->PRED = genLinkFromName(C_INV_IN);
													node->NEXT = ptr->SOURCE->NEXT;
													ptr->SOURCE->NEXT = node;
													node->PRED->SIG = sig;
													node->PRED->SOURCE = ptr->SOURCE;
													node->PRED->SOURCE->OUTSIG = sig;
													node->PRED->DEST = node;
													ptr->SOURCE = node;
													node->SUCC = ptr;
													ptr->SIG = not;
													ptr->INV = 0;
													free(signame);
												}
												ptr->SIG = not;
								}
								ptr = ptr->SUCC;
}
}

//////////////////////////////
void
genConnectors (NODE)
{
}

/*lofig_list *
genLofigFromFig (FIG)
     c_fig_list *FIG;
{
  c_node_list *ptr;
  lofig_list *new, *models;
  if (FIG == NULL)
    return NULL;
  ptr = FIG->NODELIST;
  new = addlofig (FIG->FIGNAME);
  models = NULL;
  while (ptr != NULL)
    {
      models = addModelFromNode (ptr, models);
      ptr = ptr->NEXT;
    }

  return new;
}*/
