/*------------------------------------------------------------\
|                                                             |
| This file is part of the Alliance CAD System Copyright      |
| (C) Laboratoire LIP6 - Dpartement ASIM Universite P&M Curie|
|                                                             |
| Home page      : http://www-asim.lip6.fr/alliance/          |
| E-mail support : mailto:alliance-support@asim.lip6.fr       |
|                                                             |
| This progam is  free software; you can redistribute it      |
| and/or modify it under the  terms of the GNU Library General|
| Public License as published by the Free Software Foundation |
| either version 2 of the License, or (at your option) any    |
| later version.                                              |
|                                                             |
| Alliance VLSI  CAD System  is distributed  in the hope that |
| it  will be useful, but WITHOUT  ANY WARRANTY;              |
| without even the  implied warranty of MERCHANTABILITY or    |
| FITNESS FOR A PARTICULAR PURPOSE. See the GNU General       |
| Public License for more details.                            |
|                                                             |
| You should have received a copy  of the GNU General Public  |
| License along with the GNU C Library; see the file COPYING. |
| If not, write to the Free Software Foundation, Inc.,        |
| 675 Mass Ave, Cambridge, MA 02139, USA.                     |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------\
|                                                       |
|  Title   :            Main (c4map)  									|
|                                                       |
|  Date    :             30.10.01                       |
|                                                       |
|  Authors :  Greiner Alain, Beaudenon Vincent          |
|                                                       |
\------------------------------------------------------*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include MUT_H
#include AUT_H
#include ABL_H
#include BDD_H
#include ABE_H
#include ABV_H
#include ABT_H

//#include MLO_H
//#include MLU_H
//#include MPH_H

#include "reportInv.h"
#include "node.h"
#include "optim.h"
#include "fig.h"
#include "lofig.h"

/*--------------------------------------------------------------\
|                                                             	|
|                             main                            	|
|                                                               |
\--------------------------------------------------------------*/

int
main (argc, argv)
     int argc;
     char *argv[];

{
  char *InputFileName;
  char *OutputFileName;
  int Number;
  int Index;
  char Option;
  befig_list *BEFIG /*, *BEFIG2 */ ;
  int FlagVerbose = 0;
  int FlagPower = 0;
  int FlagCarac = 0;
  int FlagNetlist = 0;
  int FlagLayout = 0;

  //A MOI
//  c_node_list *NODE;
//      c_link_list *LINK;
  c_fig_list *FIG;
  InputFileName = (char *) 0;
  OutputFileName = (char *) 0;

  for (Number = 1; Number < argc; Number++)
    {
      if (argv[Number][0] == '-')
	{
	  for (Index = 1; argv[Number][Index] != '\0'; Index++)
	    {
	      Option = argv[Number][Index];

	      switch (Option)
		{
		case 'C':
		  FlagCarac = 1;
		  break;
		case 'V':
		  FlagVerbose = 1;
		  break;
		case 'P':
		  FlagPower = 1;
		  break;
		case 'N':
		  FlagNetlist = 1;
		  break;
		case 'L':
		  FlagLayout = 1;
		  break;
		default:
		  ;
		}
	    }
	}
      else if (InputFileName == (char *) 0)
	InputFileName = argv[Number];
      else if (OutputFileName == (char *) 0)
	OutputFileName = argv[Number];
      else
	return 0;
    }

  if (InputFileName == (char *) 0)
    return 0;
  if (OutputFileName == (char *) 0)
    OutputFileName = InputFileName;

// chargement de la befig et appel de C4_main
//if (namealloc("N")==namealloc("n")) printf("CA CHIE\n");
  BEFIG = vhdlloadbefig ((befig_list *) 0, InputFileName, 3);
//      vhdlsavebefig(BEFIG, OutputFileName);

//      viewablexpr (BEFIG->BEOUT->ABL, 0);
//      flatablexpr (BEFIG->BEOUT->ABL);
//  BEFIG->BEOUT->ABL=reportInv(BEFIG->BEOUT->ABL);
//      printf("\n");
//      viewablexpr (BEFIG->BEOUT->ABL, 0);
  FIG = genFig (BEFIG);
//  showFig (FIG);
  optimFig (FIG, 4, 4);
//  showFig (FIG);
      restructFig(FIG);
//      showFig(FIG);
      optimInverters(FIG);
//      showFig(FIG);
      genLofigFromFig(FIG);
//showFig(FIG);
			return 0;
}
