/*------------------------------------------------------------\
|                                                             |
| This file is part of the Alliance CAD System Copyright      |
| (C) Laboratoire LIP6 - Dpartement ASIM Universite P&M Curie|
|                                                             |
| Home page      : http://www-asim.lip6.fr/alliance/          |
| E-mail support : mailto:alliance-support@asim.lip6.fr       |
|                                                             |
| This progam is  free software; you can redistribute it      |
| and/or modify it under the  terms of the GNU Library General|
| Public License as published by the Free Software Foundation |
| either version 2 of the License, or (at your option) any    |
| later version.                                              |
|                                                             |
| Alliance VLSI  CAD System  is distributed  in the hope that |
| it  will be useful, but WITHOUT  ANY WARRANTY;              |
| without even the  implied warranty of MERCHANTABILITY or    |
| FITNESS FOR A PARTICULAR PURPOSE. See the GNU General       |
| Public License for more details.                            |
|                                                             |
| You should have received a copy  of the GNU General Public  |
| License along with the GNU C Library; see the file COPYING. |
| If not, write to the Free Software Foundation, Inc.,        |
| 675 Mass Ave, Cambridge, MA 02139, USA.                     |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------\
|                                                       |
|  Title   :            node (c4map)  									|
|                                                       |
|  Date    :             30.10.01                       |
|                                                       |
|  Authors :  Greiner Alain, Beaudenon Vincent          |
|                                                       |
\------------------------------------------------------*/
#ifndef __C4MAP_NODE_H__
#define __C4MAP_NODE_H__
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include MUT_H
#include AUT_H
#include ABL_H
#include BDD_H
#include ABE_H
#include ABV_H
#include ABT_H
#include MLO_H
#include MLU_H
#include MPH_H
#include LOG_H

#include "reportInv.h"
#include "tree.h"
#include "link.h"
#include "names.h"
//#define PREFIXE "c4mg_"
//#define GNAMESEP '.'
//#define NAMESEP ' '

#define IN_NODE 1
#define OUT_NODE 2
#define AUX_NODE 4
#define REG_NODE 8
#define BUS_NODE 16
#define C4_NODE 32
#define XOR_NODE 33
#define NXOR_NODE 34
//#define REGIN_NODE 9
//#define REGOUT_NODE 10
#define INV_NODE 64

//#define SYNTH_NODE 8;

typedef struct c_node
{
  struct c_node *NEXT;
  char *SIGNAME;
  char TYPE_TOPO;
  char TYPE_FONC;
  char INV;
  struct c_tree *TREE;
  double U;
  double D;
  struct c_link *PRED;
  struct c_link *SUCC;
  lofig_list *LOFIG;
	losig_list *OUTSIG;
}
c_node_list;

c_node_list *genNodeFromBefig (befig_list *);
void genDAGFromNode (c_node_list *);
void showNode (c_node_list *);
c_node_list *genNodeFromName(char *);
c_node_list *searchNode (char *, c_node_list *);
c_node_list *removeUnaryNodes(c_node_list *);
befig_list *genBefigFromNode (c_node_list *);
#endif
