/*------------------------------------------------------------\
|                                                             |
| This file is part of the Alliance CAD System Copyright      |
| (C) Laboratoire LIP6 - Dpartement ASIM Universite P&M Curie|
|                                                             |
| Home page      : http://www-asim.lip6.fr/alliance/          |
| E-mail support : mailto:alliance-support@asim.lip6.fr       |
|                                                             |
| This progam is  free software; you can redistribute it      |
| and/or modify it under the  terms of the GNU Library General|
| Public License as published by the Free Software Foundation |
| either version 2 of the License, or (at your option) any    |
| later version.                                              |
|                                                             |
| Alliance VLSI  CAD System  is distributed  in the hope that |
| it  will be useful, but WITHOUT  ANY WARRANTY;              |
| without even the  implied warranty of MERCHANTABILITY or    |
| FITNESS FOR A PARTICULAR PURPOSE. See the GNU General       |
| Public License for more details.                            |
|                                                             |
| You should have received a copy  of the GNU General Public  |
| License along with the GNU C Library; see the file COPYING. |
| If not, write to the Free Software Foundation, Inc.,        |
| 675 Mass Ave, Cambridge, MA 02139, USA.                     |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------\
|                                                       |
|  Title   :            Optim (c4map) 									|
|                                                       |
|  Date    :             30.10.01                       |
|                                                       |
|  Authors :  Greiner Alain, Beaudenon Vincent          |
|                                                       |
\------------------------------------------------------*/
#include "optim.h"


void
decompTree (TREE, NMAX, PMAX)
     c_tree_list *TREE;
     int NMAX;
     int PMAX;
{
  c_tree_list *new;
  c_tree_list *min;
  c_tree_list *ptr;
//  int max;
//      double timeU, timeD;
  if (TREE == NULL)
    return;
  if (isLeaf (TREE))
    return;
  if (TREE->SUP == NULL)
    return;
  ptr = TREE->SUP;
  while (ptr != NULL)
    {
      getDelay (ptr);
      ptr = ptr->NEXT;
    }
//      printf("DECOMP\n");     
//      showTreeSp(TREE,3);
  new = genTreeFromOper (TREE->OPER);
  new->N = 0;
  new->P = 0;
  if (TREE->OPER == ABL_AND)
    {
      min = getMinU (TREE->SUP);
      if ((TREE->N - min->N + 1) <= NMAX)
	{
//                                                      printf("  BALANCEE\n");
	  genRoot (min);
	  TREE->N = getSumN (TREE->SUP);
	  TREE->P = getMaxP (TREE->SUP);
	  TREE->U = getMaxU (TREE->SUP)->U + ((TREE->ARITY) - 1) * C_TN;
	  TREE->D = getMaxD (TREE->SUP)->D;
	}

      else
	{
//                                                      printf("  NON BALANCEE\n");
	  while (new->N < NMAX)
	    {
//        printf ("W");
	      min = getMinU (TREE->SUP /*,0 */ );
	      if ((new->N + min->N) <= NMAX)
		{
		  removeSon (TREE, min);
		  insertSon (new, min);
		  new->N = new->N + min->N;
		}
	      else
		break;
	    }
	  if (new->ARITY <= 1)
	    {
//        printf("DECOMP : UN SEUL OPERANDE\n");
//              showTreeSp(TREE,5);
	      genRoot (new->SUP);
	      insertSon (TREE, new->SUP);
//        exit(-1);
	      TREE->N = getSumN (TREE->SUP);
	      TREE->P = getMaxP (TREE->SUP);

	      free (new);
	    }
	  else
	    {
//        new->SIGNAME = namealloc (giveName ());
//        printf("DECOMP : Plusieurs Oprandes\n");
	      insertSon (TREE, new);

	      new->D = getMaxD (new->SUP)->D;
	      new->U = getMaxU (new->SUP)->U + (new->ARITY - 1) * C_TN;
	      getDelay (new);
	      genRoot (new);
	      TREE->D = getMaxD (TREE->SUP)->D;
	      TREE->U = getMaxU (TREE->SUP)->U + (new->ARITY - 1) * C_TN;
	      TREE->P = getMaxP (TREE->SUP);
	      TREE->N = getSumN (TREE->SUP);
	    }
	}
      ptr = TREE->SUP;
      while (ptr != NULL)
	{
	  tegDelay (ptr);
	  ptr = ptr->NEXT;
	}
      getDelay (new);

      if (TREE->N > NMAX)
	decompTree (TREE, NMAX, PMAX);
    }
  else if (TREE->OPER == ABL_OR)
    {
      min = getMinD (TREE->SUP);
      if ((TREE->P - min->P + 1) <= PMAX)
	{
//                              printf("  BALANCEE\n");
	  genRoot (min);
	  TREE->N = getMaxN (TREE->SUP);
	  TREE->P = getSumP (TREE->SUP);
	  TREE->U = getMaxD (TREE->SUP)->D + ((TREE->ARITY) - 1) * C_TP;
	  TREE->D = getMaxU (TREE->SUP)->U;
	  return;
	}
      else
	{
//                                                      printf("  NON BALANCEE\n");
	  while (new->N < PMAX)
	    {
//        printf ("W");
	      min = getMinD (TREE->SUP /*,0 */ );
	      if ((new->P + min->P) <= PMAX)
		{
		  removeSon (TREE, min);
		  insertSon (new, min);
		  new->P = new->P + min->P;
		}
	      else
		break;
	    }
	  if (new->ARITY <= 1)
	    {
//        printf("DECOMP : UN SEUL OPERANDE\n");
//    exit(-1);
//              showTreeSp(TREE,5);
	      genRoot (new->SUP);
	      insertSon (TREE, new->SUP);
	      TREE->P = getSumP (TREE->SUP);
	      TREE->N = getMaxN (TREE->SUP);
	      free (new);
	    }
	  else
	    {
//        new->SIGNAME = namealloc (giveName ());
//        printf("DECOMP : Plusieurs Oprandes\n");
	      insertSon (TREE, new);
	      new->U = getMaxU (new->SUP)->U;
	      new->D = getMaxD (new->SUP)->D + (new->ARITY - 1) * C_TP;
	      getDelay (new);
	      genRoot (new);
	      TREE->U = getMaxU (TREE->SUP)->U;
	      TREE->D = getMaxD (TREE->SUP)->D + (TREE->ARITY - 1) * C_TP;
	      TREE->N = getMaxN (TREE->SUP);
	      TREE->P = getSumP (TREE->SUP);
	    }
	}
      ptr = TREE->SUP;
      while (ptr != NULL)
	{
	  tegDelay (ptr);
	  ptr = ptr->NEXT;
	}
      if (TREE->P > PMAX)
	decompTree (TREE, NMAX, PMAX);
    }
  else
    return;
}

void
decompXOR (TREE)
     c_tree_list *TREE;
{
  c_tree_list *new;
  c_tree_list *min;
  double timeU, timeD;
  if (TREE == NULL)
    return;
  if (isLeaf (TREE))
    return;
  if (TREE->SUP == NULL)
    return;
  if (TREE->ARITY < 3)
    {
      timeU = (getMaxU (TREE->SUP))->U;
      timeD = (getMaxD (TREE->SUP))->D;
      if (timeD > timeU)
	{
	  TREE->D = timeD + C_TXDD;
	  TREE->U = timeD + C_TXDU;
	}
      else
	{
	  TREE->D = timeU + C_TXUD;
	  TREE->U = timeU + C_TXUU;
	}
      genRoot (TREE);
//      TREE->SIGNAME = namealloc (giveName ());
      return;
    }
  new = genTreeFromOper (ABL_XOR);
  min = getMinUD (TREE->SUP);
  removeSon (TREE, min);
  insertSon (new, min);
  min = getMinUD (TREE->SUP);
  removeSon (TREE, min);
  insertSon (new, min);
  insertSon (TREE, new);
  timeU = (getMaxU (new->SUP))->U;
  timeD = (getMaxD (new->SUP))->D;
  if (timeD > timeU)
    {
      new->D = timeD + C_TXDD;
      new->U = timeD + C_TXDU;
    }
  else
    {
      new->D = timeU + C_TXUD;
      new->U = timeU + C_TXUU;
    }
  decompXOR (TREE);
}

void
decompNXOR (TREE)
     c_tree_list *TREE;
{
  decompXOR (TREE);
  TREE->OPER = ABL_NXOR;
}

//****************** OPTIMISATIONS ********************

void
optimTree (TREE, NMAX, PMAX, GEN)
     c_tree_list *TREE;
     int NMAX;
     int PMAX;
     int GEN;
{
  c_tree_list *ptr;
  int /*sumn, sump, maxn, maxp, */ gen;
  // double maxd, maxu;
  if (TREE == NULL)
    {
      printf ("TREE = NULL !!!\n");
      exit;
      return;
    }
//  if (isLeaf (TREE))
//  printf ("OP :%c", oToC (TREE->OPER));
  if (TREE->VAR != NULL)
    {
      optimNode (TREE->VAR->SOURCE, NMAX, PMAX);
      TREE->U = TREE->VAR->SOURCE->U + C_TN;
      TREE->D = TREE->VAR->SOURCE->D + C_TP;
      if (TREE->VAR->INV == 1)
	{
	  TREE->U = TREE->U + C_TINV;
	  TREE->D = TREE->D + C_TINV;
	}
    }
// OPERATEUR AND/OR/XOR/NXOR UNIQUEMENT
/*  sumn = 0;
  sump = 0;
  maxn = 1;
  maxp = 1;*/
  gen = 0;
/*  maxd = 0;
  maxu = 0;*/
  ptr = TREE->SUP;
  if (GEN == 1)
    {
//      TREE->ROOT = 1;
//      TREE->N = 1;
//      TREE->P = 1;
    }
  if (TREE->OPER == ABL_XOR)
    gen = 1;
  if (TREE->OPER == ABL_NXOR)
    gen = 1;

  while (ptr != NULL)
    {
//      printf ("W");
      optimTree (ptr, NMAX, PMAX, gen);
/*      if (maxn < ptr->N)
	maxn = ptr->N;
      if (maxp < ptr->P)
	maxp = ptr->P;
      sumn = sumn + ptr->N;
      sump = sump + ptr->P;
      if (ptr->D > maxd)
	maxd = ptr->D;
      if (ptr->U > maxu)
	maxu = ptr->U;
  */ ptr = ptr->NEXT;
    }

  if (TREE->OPER == ABL_OR)
    {
      TREE->N = getMaxN (TREE->SUP);
      TREE->P = getSumP (TREE->SUP);
      TREE->D = getMaxD (TREE->SUP)->D + ((TREE->ARITY) - 1) * C_TP;
      TREE->U = getMaxU (TREE->SUP)->U;
      if (TREE->P > PMAX)
	decompTree (TREE, NMAX, PMAX);
      if ((TREE->N == NMAX) /*||(GEN==1) */ )
	{
//        printf("GENROOOOOOT ! AND\n");
	  getDelay (TREE);
	  genRoot (TREE);
//              showTreeSp(TREE,3);
	}
    }
  else if (TREE->OPER == ABL_AND)
    {
      TREE->P = getMaxP (TREE->SUP);
      TREE->N = getSumN (TREE->SUP);
      TREE->U = getMaxU (TREE->SUP)->U + ((TREE->ARITY) - 1) * C_TN;
      TREE->D = getMaxD (TREE->SUP)->D;
      if (TREE->N > NMAX)
	decompTree (TREE, NMAX, PMAX);
      if ((TREE->P == PMAX) /*||(GEN==1) */ )
	{
//        printf("GENROOOOOOT ! OR \n");
	  getDelay (TREE);
	  genRoot (TREE);
	}
    }
  else if (TREE->OPER == ABL_XOR)
    {
      decompXOR (TREE);
    }
  else if (TREE->OPER == ABL_NXOR)
    {
      decompNXOR (TREE);
    }
  else if ((TREE->N == NMAX) && (TREE->P == PMAX))
    {
      getDelay (TREE);
      genRoot (TREE);
//      TREE->SIGNAME = namealloc (giveName ());
    }
/*  else if ((TREE->N > NMAX) || (TREE->P > PMAX))
    {
      decompTree (TREE, NMAX, PMAX);
    }*/
  if (GEN == 1)
    {
      getDelay (TREE);
      genRoot (TREE);
//      TREE->SIGNAME = namealloc (giveName ());
    }
//      orderTree(TREE);
//      extractGName(TREE);
}

void
optimNode (NODE, NMAX, PMAX)
     c_node_list *NODE;
     int NMAX;
     int PMAX;
{
c_link_list *ptr;
	if (NODE == NULL)
    return;
  if (NODE->TYPE_TOPO == IN_NODE)
    return;
  if (NODE->TREE != NULL)
//    return;
  if (NODE->TREE->ROOT == 1)
    return;
	if (NODE->TYPE_FONC==C4_NODE) {
  NODE->TREE->ROOT = 0;
  optimTree (NODE->TREE, NMAX, PMAX, 0);
  getDelay (NODE->TREE);
  genRoot (NODE->TREE);
  NODE->D = NODE->TREE->D;
  NODE->U = NODE->TREE->U;
	return;
	}
	if (NODE->TYPE_FONC==BUS_NODE) {
	if (NODE->U>0) return;
	ptr = NODE->PRED;
	while (ptr!=NULL) {optimNode(ptr->SOURCE,NMAX,PMAX); ptr = ptr->PRED;}
	getBusDelay (NODE);
	return;
	}
}

void
optimNodeList (NODE, NMAX, PMAX)
     c_node_list *NODE;
     int NMAX;
     int PMAX;
{
  c_node_list *ptr;
  if (NODE == NULL)
    {
      return;
    }
  ptr = NODE;
  while (ptr != NULL)
    {
      optimNode (ptr, NMAX, PMAX);
      ptr = ptr->NEXT;
    }
}


//***************** RESTRUCTURATION ****************************

///*c_node_list * */void restructNode(c_node_list *, c_node_list *);

/*c_node_list * */ void
restructTree (TREE, NODE)
     c_tree_list *TREE;
     c_node_list *NODE;
{
  c_tree_list *ptr;
  c_link_list *link;
  c_node_list *node;
  c_tree_list *tree;
  if (TREE == NULL)
    return /*NEXTNODE*/;
  if (TREE->VAR != NULL)
    {
      TREE->VAR->DEST = NODE;
      return;
    }
//printf("RESTRUCT TREE\n");showTreeSp(TREE,8);
  ptr = TREE->SUP;
  while (ptr != NULL)
    {
      if (ptr->ROOT == 1)
	{
	  ptr->SIGNAME = namealloc (giveName ());
	  link = genLinkFromName (ptr->SIGNAME);
	  link->DEST = NODE;
		node =genNodeFromName(ptr->SIGNAME);
	  node->TYPE_TOPO = AUX_NODE;
	  node->TYPE_FONC= C4_NODE;
	  link->SOURCE = node;
	  tree = copyTree (ptr);
	  tree->NODE = node;
	  node->TREE = tree;
	  tree->U = TREE->U;
	  tree->D = TREE->D;
	  node->U = TREE->U;
	  node->D = TREE->D;
	  ptr->SUP = NULL;
	  ptr->OPER = ABL_MAX_OPERATOR + 1;
	  ptr->ARITY = 1;
	  ptr->N = 1;
	  ptr->P = 1;
	  ptr->VAR = link;
	  node->NEXT = NODE->NEXT;
	  NODE->NEXT = node;
	}
      else
	restructTree (ptr, NODE);
      ptr = ptr->NEXT;
    }
/*return TREE->NODE;*/
}

/*c_node_list* */
/*c_link_list *
restructNode (NODE, LINK)
     c_node_list *NODE;
     c_link_list *LINK;
{
  c_link_list *ptr;
  if (NODE == NULL)
    return LINK;
  if (NODE->TYPE_FONC != C4_NODE)
    return LINK;
  if (NODE->TYPE_TOPO == IN_NODE)
    return LINK;
  restructTree (NODE->TREE, NODE);
  normalizeTree (NODE->TREE);
//      showTreeSp(NODE->TREE,5);
//      printf("RESTRUCT NODE %s\n",NODE->SIGNAME);
  genPredList (NODE);
  ptr = NODE->PRED;
  while (ptr != NULL)
    {
      LINK = addSuccList (LINK, ptr);
      ptr = ptr->PRED;
    }
  NODE->TREE->ROOT = 1;
  return LINK;
}*/

c_link_list *
restructNode (NODE, LINK)
     c_node_list *NODE;
     c_link_list *LINK;
{
  c_link_list *ptr;
  if (NODE == NULL)
    return LINK;
  if ((NODE->TYPE_FONC == C4_NODE) && (NODE->TYPE_TOPO != IN_NODE))
	{
  restructTree (NODE->TREE, NODE);
  normalizeTree (NODE->TREE);
//      showTreeSp(NODE->TREE,5);
//      printf("RESTRUCT NODE %s\n",NODE->SIGNAME);
  if (NODE->TREE->OPER==ABL_XOR) {
					NODE->TYPE_FONC=XOR_NODE;
	}
	else if (NODE->TREE->OPER==ABL_NXOR) {
					NODE->TYPE_FONC = NXOR_NODE;
	}
	genPredList (NODE);}
  ptr = NODE->PRED;
  while (ptr != NULL)
    {
      LINK = addSuccList (LINK, ptr);
      ptr = ptr->PRED;
    }
//  NODE->TREE->ROOT = 1;
  return LINK;
}





/*c_node_list*/
c_link_list *
restructNodeList (NODE)
     c_node_list *NODE;
{
  c_node_list *ptr;
  c_link_list *link;
  if (NODE == NULL)
    return NULL;
  ptr = NODE;
  link = NULL;
  while (ptr != NULL)
    {
      link = restructNode (ptr, link);
      ptr = ptr->NEXT;
    }
	ptr = NODE;
	while (ptr!=NULL)
	{
		if (ptr->TYPE_TOPO==OUT_NODE) {
						ptr->SUCC = genLinkFromName(ptr->SIGNAME);
						ptr->SUCC->SOURCE = ptr;
						link = addSuccList(link,ptr->SUCC);
//						ptr->SUCC->SUCC = link;
//						link=ptr->SUCC;
		}
		ptr = ptr->NEXT;
	}
  return link;
}

void
optimInv (NODE)
     c_node_list *NODE;
{
  c_node_list *ptr;
  c_link_list *link;
//float ninv,ntot;
  if (NODE == NULL)
    return;
  ptr = NODE;
  while (ptr != NULL)
    {
      if ((ptr->TYPE_TOPO != IN_NODE) && (ptr->TYPE_FONC==C4_NODE) && (ptr->SUCC != NULL))
	{
	  link = ptr->SUCC;
//                              showLinkSp(link,5);
//                              ntot = (float)link->NTOT;
//                              ninv = (float)link->NINV;
//                              printf("%f %f\n",ntot,ninv);
	  if ((link->NTOT == link->NINV) && (link->NTOT>0))
	    {
	      while ((link != NULL) && (link->SOURCE == ptr))
		{
		  link->INV = !(link->INV);
		  link = link->SUCC;
		}
	      ptr->INV = 1;
	    }
	}
      ptr = ptr->NEXT;
    }
}

void
setInverters (NODE)
     c_node_list *NODE;
{
  c_node_list *ptr;
  c_tree_list *new;
  char *name;
  if (NODE == NULL)
    return;
  ptr = NODE;
  while (ptr != NULL)
    {
      if (ptr->INV == 1)
	{
	  if (ptr->TREE != NULL)
	    {
	      new = genTreeFromOper (ABL_NOT);
	      name = malloc ((strlen (ptr->TREE->GNAME + 3)) * sizeof (char));
	      sprintf (name, "n%s1", ptr->TREE->GNAME);
	      new->GNAME = namealloc (name);
	      free (name);
	      new->SUP = NODE->TREE;
	      NODE->TREE = new;
	    }
	}
      ptr = ptr->NEXT;
    }
}
