/*------------------------------------------------------------\
|                                                             |
| This file is part of the Alliance CAD System Copyright      |
| (C) Laboratoire LIP6 - Dpartement ASIM Universite P&M Curie|
|                                                             |
| Home page      : http://www-asim.lip6.fr/alliance/          |
| E-mail support : mailto:alliance-support@asim.lip6.fr       |
|                                                             |
| This progam is  free software; you can redistribute it      |
| and/or modify it under the  terms of the GNU Library General|
| Public License as published by the Free Software Foundation |
| either version 2 of the License, or (at your option) any    |
| later version.                                              |
|                                                             |
| Alliance VLSI  CAD System  is distributed  in the hope that |
| it  will be useful, but WITHOUT  ANY WARRANTY;              |
| without even the  implied warranty of MERCHANTABILITY or    |
| FITNESS FOR A PARTICULAR PURPOSE. See the GNU General       |
| Public License for more details.                            |
|                                                             |
| You should have received a copy  of the GNU General Public  |
| License along with the GNU C Library; see the file COPYING. |
| If not, write to the Free Software Foundation, Inc.,        |
| 675 Mass Ave, Cambridge, MA 02139, USA.                     |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------\
|                                                       |
|  Title   :          reportInv (c4map)									|
|                                                       |
|  Date    :             30.10.01                       |
|                                                       |
|  Authors :  Greiner Alain, Beaudenon Vincent          |
|                                                       |
\------------------------------------------------------*/
#include "reportInv.h"

//Report Inverseurs avec Polarite (sous prog de reportInv, voir plus bas)

ablexpr *
reportInvPol (Expr, Pol)
     ablexpr *Expr;
     int Pol;
{
  ablexpr *new, *ptr = Expr;
  if (!ABL_ATOM (Expr))
    {
      if (ABL_OPER (Expr) == ABL_NOT)
	{
	  return reportInvPol ((ABL_CADR (Expr)), !Pol);
	}
      else if ((ABL_OPER (Expr) < ABL_NXOR) && (ABL_OPER (Expr) >= ABL_NOR))
	{
	  new = createabloper (ABL_OPER (Expr) - 4);
	  ABL_CDR (new) = ABL_CDR (Expr);
	  return reportInvPol (new, !Pol);
	}
      else if ((ABL_OPER (Expr) == ABL_XOR) && Pol == 0)
	{
	  new = createabloper (ABL_NXOR);
	  ABL_CDR (new) = ABL_CDR (Expr);
	  return reportInvPol (new, 1);
	}
      else if ((ABL_OPER (Expr) == ABL_NXOR) && Pol == 0)
	{
	  new = createabloper (ABL_XOR);
	  ABL_CDR (new) = ABL_CDR (Expr);
	  return reportInvPol (new, 1);
	}
      else
	{
	  if (Pol == 0)
	    {
	      new = createabloper (!ABL_OPER (Expr));
	      ABL_CDR (new) = ABL_CDR (Expr);
	      while ((ptr = ABL_CDR (ptr)) != (ablexpr *) 0)
		ABL_CAR (ptr) = reportInvPol (ABL_CAR (ptr), 0);
	      return new;
	    }
	  else
	    {
	      while ((ptr = ABL_CDR (ptr)) != (ablexpr *) 0)
		ABL_CAR (ptr) = reportInvPol (ABL_CAR (ptr), 1);
	      return Expr;
	    }
	}
    }
  else if (Pol == 1)
    {
      return Expr;
    }
  else
    {
      new = createablnotexpr (Expr);
      return new;
    }
}

//Report des inverseurs

ablexpr *
reportInv (Expr)
     ablexpr *Expr;
{
  return reportInvPol (Expr, 1);
}

//****************************
