/*------------------------------------------------------------\
|                                                             |
| This file is part of the Alliance CAD System Copyright      |
| (C) Laboratoire LIP6 - Dpartement ASIM Universite P&M Curie|
|                                                             |
| Home page      : http://www-asim.lip6.fr/alliance/          |
| E-mail support : mailto:alliance-support@asim.lip6.fr       |
|                                                             |
| This progam is  free software; you can redistribute it      |
| and/or modify it under the  terms of the GNU Library General|
| Public License as published by the Free Software Foundation |
| either version 2 of the License, or (at your option) any    |
| later version.                                              |
|                                                             |
| Alliance VLSI  CAD System  is distributed  in the hope that |
| it  will be useful, but WITHOUT  ANY WARRANTY;              |
| without even the  implied warranty of MERCHANTABILITY or    |
| FITNESS FOR A PARTICULAR PURPOSE. See the GNU General       |
| Public License for more details.                            |
|                                                             |
| You should have received a copy  of the GNU General Public  |
| License along with the GNU C Library; see the file COPYING. |
| If not, write to the Free Software Foundation, Inc.,        |
| 675 Mass Ave, Cambridge, MA 02139, USA.                     |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------\
|                                                       |
|  Title   :            tree (c4map)  									|
|                                                       |
|  Date    :             30.10.01                       |
|                                                       |
|  Authors :  Greiner Alain, Beaudenon Vincent          |
|                                                       |
\------------------------------------------------------*/
#ifndef __C4MAP_TREE_H__
#define __C4MAP_TREE_H__
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include MUT_H
#include AUT_H
#include ABL_H
#include BDD_H
#include ABE_H
#include ABV_H
#include ABT_H

#include "reportInv.h"
#include "giveName.h"
#include "link.h"
#include "delay.h"
#include "names.h"
//#define PREFIXE "c4mg_"
//#define GNAMESEP '.'
//#define NAMESEP ' '

/*

// C4 CELLS
#define C_TN 100
#define C_TP 150
#define C_TUU 500
#define C_TDD 500
#define C_TDU 600
#define C_TUD 600

// INVERTERS
#define C_TINV 100

// XOR CELLS
#define C_TXUU 800
#define C_TXDD 800
#define C_TXUD 800
#define C_TXDU 800
*/
typedef struct c_tree
{
  struct c_tree *NEXT;
  char *SIGNAME;
  char *GNAME;
  long OPER;
  char ARITY;
  struct c_tree *SUP;
  char N;
  char P;
  double U;
  double D;
  struct c_node *NODE;
  struct c_link *VAR;
  char ROOT;
}
c_tree_list;

//Divers
char oToC (long);

//Generation
c_tree_list *genTreeFromABL (ablexpr *);
c_tree_list *genTreeFromOper (long);
//Affichage
void showTreeSp (c_tree_list *, int);
void showTree (c_tree_list *);

//Tests
int isLeaf (c_tree_list *);

//Copy
c_tree_list *copyTree (c_tree_list *);

//ORDER
void orderTree (c_tree_list *);

//GNAME
void extractGName (c_tree_list *);

//Normalization
void normalizeTree (c_tree_list *);

//TREE->ABL
ablexpr *genABLFromTree (c_tree_list *);

void genRoot (c_tree_list *);

void removeSon (c_tree_list *, c_tree_list *);

void insertSon (c_tree_list *, c_tree_list *);

void getDelay (c_tree_list *);
void tegDelay (c_tree_list *);

c_tree_list *getMaxU (c_tree_list *);
c_tree_list *getMaxD (c_tree_list *);
c_tree_list *getMinU (c_tree_list *);
c_tree_list *getMinD (c_tree_list *);
c_tree_list *getMinUD (c_tree_list *);

int getMaxP (c_tree_list *);
int getMaxN (c_tree_list *);
int getSumN (c_tree_list *);
int getSumP (c_tree_list *);

#endif
