/*
 * This file is part of the Alliance CAD System
 * Copyright (C) Laboratoire LIP6 - Dpartement ASIM
 * Universite Pierre et Marie Curie
 * 
 * Home page          : http://www-asim.lip6.fr/alliance/
 * E-mail support     : mailto:alliance-support@asim.lip6.fr
 * 
 * This progam is  free software; you can redistribute it  and/or modify it
 * under the  terms of the GNU  General Public License as  published by the
 * Free Software Foundation;  either version 2 of the License,  or (at your
 * option) any later version.
 * 
 * Alliance VLSI  CAD System  is distributed  in the hope  that it  will be
 * useful, but WITHOUT  ANY WARRANTY; without even the  implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details.
 * 
 * You should have received a copy  of the GNU General Public License along
 * with the GNU C Library; see the  file COPYING. If not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*********************************************************************\

    File        :   placer_utils.h

    Date        :   27-09-94
    Version     :   1

    Auteur      :   BEAURIN oliver

\*********************************************************************/

#ifndef PLACER_UTILS_H
#define PLACER_UTILS_H

/*---------------------------------------------------------\
                     includes
\---------------------------------------------------------*/
#include MLO_H
#include MPH_H

#include "placer_structure.h"

/*---------------------------------------------------------\
                     prototypes
\---------------------------------------------------------*/
#ifdef __STDC__

extern void  freelofigchain            ( lofig_list * );
extern long  nbcells_of_lofig          ( char * );
extern long  YtoSlice                  ( placement *, column *, con_EW * );
extern char *getonemorelevelconname    ( char *, lofig_list *, char * );
extern char *get_con_name_from_ref_name( char * );
extern long  getindex                  ( char * );
extern int   isindexed                 ( char * );
extern char  islogic_column            ( char *, long );

#else

extern void  freelofigchain            ( );
extern long  nbcells_of_lofig          ( );
extern long  YtoSlice                  ( );
extern char *getonemorelevelconname    ( );
extern char *get_con_name_from_ref_name( );
extern long  getindex                  ( );
extern int   isindexed                 ( );
extern char  islogic_column            ( );

#endif

#endif /* PLACER_UTILS_H */
