/*
 * This file is part of the Alliance CAD System
 * Copyright (C) Laboratoire LIP6 - Dpartement ASIM
 * Universite Pierre et Marie Curie
 * 
 * Home page          : http://www-asim.lip6.fr/alliance/
 * E-mail support     : mailto:alliance-support@asim.lip6.fr
 * 
 * This progam is  free software; you can redistribute it  and/or modify it
 * under the  terms of the GNU  General Public License as  published by the
 * Free Software Foundation;  either version 2 of the License,  or (at your
 * option) any later version.
 * 
 * Alliance VLSI  CAD System  is distributed  in the hope  that it  will be
 * useful, but WITHOUT  ANY WARRANTY; without even the  implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details.
 * 
 * You should have received a copy  of the GNU General Public License along
 * with the GNU C Library; see the  file COPYING. If not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*********************************************************************\

    Fichier     :    strecher_supply.h

    Date        :    12 octobre 1995
    Version     :    2.0

    Auteur      :    CHAPUT Jean-Paul
    Modifie par :    BEAURIN Oliver

\*********************************************************************/

#ifndef SUPPLY_H
#define SUPPLY_H

/* Constantes du module. */
#define        C_SUPPLY_VDD        1
#define        C_SUPPLY_VSS        2

/* Structure contenant les informations relatives a une ligne
   d'alimentation VDD ou VSS. */
typedef struct supply
{
    long            YSUPPLY;    /* ordonnee de la ligne.          */
    char            TYPE;       /* type de la ligne (VDD ou VSS). */
    struct supply  *NEXT;       /* chainage.                      */
}               supply_list;


/* Fonctions d'interface du module. */
extern supply_list *getnsupply();
extern long     index_calc();
extern void    *dup_ls_supply();
extern void     extract_ls_supply();
extern int      is_out_of_supply( );

#endif                          /* SUPPLY_H */
