/*
 * $Author: ac $
 * $Id: bflpos.c,v 1.2 1999/10/21 12:51:52 ac Exp $
 * $Date: 1999/10/21 12:51:52 $
 */
/*
 * $Log: bflpos.c,v $
 * Revision 1.2  1999/10/21 12:51:52  ac
 * Nouvelle version avec les librairies bdd104, abe, abv, abt.
 * Ajout de fpm_network pour accelerer l'optimisation.
 *
 * Revision 1.1.1.1  1998/10/21 16:32:38  alliance
 * fpmap import
 *
 */

/*----------------------------------------------------------------------*/
/*                               Includes                               */
/*----------------------------------------------------------------------*/

#include <math.h>
#include  BFL_H

/*----------------------------------------------------------------------*/
/*                        Constant declarations                         */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                          Type declarations                           */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                        Stucture declarations                         */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                        Variable declarations                         */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                          Macro declarations                          */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                      Static function prototypes                      */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                    Definition of static functions                    */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                   Definition of exported functions                   */
/*----------------------------------------------------------------------*/

bflpos_t
bflposadd(bflpos_t x, bflpos_t y)
{
    bflpos_t res;

    res.x = x.x + y.x;
    res.y = x.y + y.y;
    return res;
}

bflpos_t
bflpossub(bflpos_t x, bflpos_t y)
{
    bflpos_t res;

    res.x = x.x - y.x;
    res.y = x.y - y.y;
    return res;
}

double
bflposnorm(bflpos_t x)
{
    return sqrt(x.x * x.x + x.y * x.y);
}

bflpos_t
bflposunit(bflpos_t x)
{
    bflpos_t res;
    double norm = bflposnorm(x);

    res.x = x.x / norm;
    res.y = x.y / norm;
    return res;
}

double
bflposdot(bflpos_t x, bflpos_t y)
{
    return x.x * y.x + x.y * y.y;
}
