/*
 * $Author: ac $
 * $Id: testmat.c,v 1.1 1999/10/21 12:51:54 ac Exp $
 * $Date: 1999/10/21 12:51:54 $
 */
/*
 * $Log: testmat.c,v $
 * Revision 1.1  1999/10/21 12:51:54  ac
 * Nouvelle version avec les librairies bdd104, abe, abv, abt.
 * Ajout de fpm_network pour accelerer l'optimisation.
 *
 */

#include <stdio.h>
#include  BFL_H

static void
print_int(bflptr_t ptr)
{
	printf("%2d", (int)ptr);
}

int
main()
{
	int r, c;
	bflmat_t *m;
	bflptr_t *f, *l;

	m = bflmatnew(10, 10);
	for (r = 0; r < m->row; ++r)
		for (c = 0; c < m->col; ++c)
			bflmatpos(m, r, c) = (bflptr_t)(r * 10 + c);
	bflmatprint(m, print_int);
	
	for (r = 0; r < m->row; ++r) {
		printf("row %d: ", r);
		f = bflmatrowbegin(m, r);
		l = bflmatrowend(m, r);
		while (f != l) {
			print_int(*f); putchar(' ');
			f = bflmatrownext(m, f);
		}
		putchar('\n');
	}
	
	for (c = 0; c < m->col; ++c) {
		printf("col %d: ", c);
		f = bflmatcolbegin(m, c);
		l = bflmatcolend(m, c);
		while (f != l) {
			print_int(*f); putchar(' ');
			f = bflmatcolnext(m, f);
		}
		putchar('\n');
	}
	
	return 0;
}

