/*
 * $Author: ac $
 * $Id: fpm_save.c,v 1.2 1999/10/21 12:52:07 ac Exp $
 * $Date: 1999/10/21 12:52:07 $
 */
/*
 * $Log: fpm_save.c,v $
 * Revision 1.2  1999/10/21 12:52:07  ac
 * Nouvelle version avec les librairies bdd104, abe, abv, abt.
 * Ajout de fpm_network pour accelerer l'optimisation.
 *
 * Revision 1.1.1.1  1998/10/21 16:32:41  alliance
 * fpmap import
 *
 * Revision 1.3  1998/02/11 17:34:36  ac
 * fpmap version 0.62
 *
 * Revision 1.2  1998/01/26 15:29:10  ac
 * Bug fix in the mapping function.
 *
 * Revision 1.1  1997/11/14 11:49:46  ac
 * Initial revision
 *
 */

/*----------------------------------------------------------------------*/
/*                               Includes                               */
/*----------------------------------------------------------------------*/

#include <assert.h>
#include <stdio.h>
#include  MUT_H
#include  BFL_H
#include  AUT_H
#include  ABL_H
#include  BDD_H
#include  ABE_H
#include  ABV_H
#include  BUT_H
#include "fpm_network.h"
#include "fpm_user.h"
#include "fpm_load.h"
#include "fpm_save.h"

/*----------------------------------------------------------------------*/
/*                        Constant declarations                         */
/*----------------------------------------------------------------------*/

/* #define DEBUG */

/*----------------------------------------------------------------------*/
/*                          Type declarations                           */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                        Stucture declarations                         */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                        Variable declarations                         */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                          Macro declarations                          */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                      Static function prototypes                      */
/*----------------------------------------------------------------------*/

static void fpmdecompil __P((void));

/*----------------------------------------------------------------------*/
/*                    Definition of static functions                    */
/*----------------------------------------------------------------------*/

static void
fpmdecompil()
{
	befig_list *BehFigure;
	bereg_list *BehReg;
	biabl_list *BiAbl;
	ptype_list *PtrClkType;
	ptype_list *PtrClkName;
	long ClkType;
	char *ClkName;

	BehFigure = FpmUser->BEFIG;

	for (BehReg = BehFigure->BEREG; BehReg != 0; BehReg = BehReg->NEXT) {
		for (BiAbl = BehReg->BIABL; BiAbl != 0; BiAbl = BiAbl->NEXT) {

			if (BiAbl->CNDABL != 0) {
				BiAbl->VALABL = createablbinexpr(ABL_OR,
						createablbinexpr(ABL_AND,
							   BiAbl->VALABL,
							  BiAbl->CNDABL),
						createablbinexpr(ABL_AND,
					     createablatom(BehReg->NAME),
				       createablnotexpr(BiAbl->CNDABL)));
			}
			PtrClkType = getptype(BiAbl->USER, FP_CLOCK_TYPE);
			PtrClkName = getptype(BiAbl->USER, FP_CLOCK_NAME);

			assert(PtrClkType);
			assert(PtrClkName);

			ClkType = (long) PtrClkType->DATA;
			ClkName = (char *) PtrClkName->DATA;

			switch (ClkType) {
			case FP_FF_RE:
				BiAbl->CNDABL = createablbinexpr(ABL_AND,
						  createablatom(ClkName),
							createablnotexpr(
					   createablunaryexpr(ABL_STABLE,
					       createablatom(ClkName))));
				break;

			case FP_FF_FE:
				BiAbl->CNDABL = createablbinexpr(ABL_AND,
							createablnotexpr(
						 createablatom(ClkName)),
							createablnotexpr(
					   createablunaryexpr(ABL_STABLE,
					       createablatom(ClkName))));
				break;

			case FP_LATCH_AH:
				BiAbl->CNDABL = createablatom(ClkName);
				break;

			case FP_LATCH_AL:
				BiAbl->CNDABL = createablnotexpr(createablatom(ClkName));
				break;

			}
		}
	}
}

/*----------------------------------------------------------------------*/
/*                   Definition of exported functions                   */
/*----------------------------------------------------------------------*/

void
fpm_save()
{
/*	but_sweep(FpmUser->BEFIG, BUT_SWEEP_ABL); */

	printf("\n * Saving `%s' ...\n", FpmUser->FILE_VHDL);

	(*FpmUser->ARCHI_SAVE) ();

	fpmdecompil();

	printf("   - Writing `%s.vbe' ...\n", FpmUser->FILE_EXPR);
	vhdlsavebefig(FpmUser->BEFIG, 0);
}
