/*
 * $Author: ac $
 * $Id: xnf_check.c,v 1.2 1999/10/21 12:52:15 ac Exp $
 * $Date: 1999/10/21 12:52:15 $
 */
/*
 * $Log: xnf_check.c,v $
 * Revision 1.2  1999/10/21 12:52:15  ac
 * Nouvelle version avec les librairies bdd104, abe, abv, abt.
 * Ajout de fpm_network pour accelerer l'optimisation.
 *
 * Revision 1.1.1.1  1998/10/21 16:32:42  alliance
 * fpmap import
 *
 */

/*----------------------------------------------------------------------*/
/*                               Includes                               */
/*----------------------------------------------------------------------*/

#include  MUT_H
#include  BFL_H
#include  AUT_H
#include  ABL_H
#include  ABE_H
#include  BUT_H
#include  XNF_H

/*----------------------------------------------------------------------*/
/*                        Constant declarations                         */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                          Type declarations                           */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                        Stucture declarations                         */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                        Variable declarations                         */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                          Macro declarations                          */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                      Static function prototypes                      */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                    Definition of static functions                    */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                   Definition of exported functions                   */
/*----------------------------------------------------------------------*/

void
xnf_check( BehFigure, IobMode )
    befig_list	*BehFigure;
    int		 IobMode;
{
    bereg_list *BehReg;
    bebus_list *BehBus;
    bebux_list *BehBux;
    ptype_list *Clock;
    int         Error	= 0;
    
    if (BehFigure == 0)
	bflerror(1, "xnf_check: error: figure is empty");
    
    for (BehReg = BehFigure->BEREG; BehReg != 0; BehReg = BehReg->NEXT) {
	if (BehReg->BIABL->NEXT != 0) {
	    Error = 1;
	    bflwarning("xnf_check: error: multiple drivers on register `%s'", BehReg->NAME);
	}
	Clock = getptype(BehReg->BIABL->USER, BUT_CLOCK_TYPE);
	if ((Clock == 0                        ) || 
	    (Clock->DATA == (void *)BUT_LATCH_AH) ||
	    (Clock->DATA == (void *)BUT_LATCH_AL)) {
	    Error = 1;
	    bflwarning("xnf_check: error: register `%s' is a latch", BehReg->NAME);
	}
    }

    for (BehBus = BehFigure->BEBUS; BehBus != 0; BehBus = BehBus->NEXT) {
	if (IobMode == 1  && BehBus->BIABL->NEXT != 0) {
	    Error = 1;
	    bflwarning("xnf_check: error: multiple drivers on port `%s'", BehBus->NAME);
	}
	if (BehBus->TYPE == 'W') {
	    Error = 1;
	    bflwarning("xnf_check: error: unsupported type (wor_bit) for port `%s'", BehBus->NAME);
	}
    }
    for (BehBux = BehFigure->BEBUX; BehBux != 0; BehBux = BehBux->NEXT) {
	if (BehBux->TYPE == 'W') {
	    Error = 1;
	    bflwarning("xnf_check: error: unsupported type (wor_bit) for signal `%s'", BehBux->NAME);
	}
    }
    if (Error != 0)
	bflerror(1, "xnf_check: aborting ...");
}
