/*####==============================================================####*/
/*##                                                                  ##*/
/*##  This file is part of BOUNDARY SCAN TESTER for PC/Linux Systems  ##*/
/*##  (C) 1995, 1996 MASI, CAO-VLSI Team                              ##*/
/*##                                                                  ##*/
/*##  Authors            : Philippe OLEK, Olivier SIROL (1995)        ##*/
/*##  Authors            : Eric MECHIN (1996)                         ##*/
/*##  Authors            : Francois DONNET (1998)                     ##*/
/*##                                                                  ##*/
/*##  Modifications      : Ana ABRIL (2000)                           ##*/
/*##                                                                  ##*/
/*##  E-mail support:    cao-vlsi@masi.ibp.fr                         ##*/
/*##                                                                  ##*/
/*####==============================================================####*/
/****************************************************************************/
#include "global.h"
/****************************************************************************/
/* Variables globales                                                       */
/****************************************************************************/
Infos *InfosVbe=NULL;                              /* Pour les informations */

/* flags and vars for command line processing */
int verbose_flag     = 0;              /*affichage de tous les commmentaires */
int execute_flag     = 0;                               /*mode avec hardware */
int savePatSRC_flag  = 0;                            /*sauvegardr pattern // */
int savePatBS_flag   = 0;                           /*sauvegarder pattern BS */
int check_flag       = 0;                             /*est-ce le mode check */
int emulbs_flag      = 0;                /*est-ce pour l'interface EMULBS31? */
static int bsdl_flag = 0;                                 /*bsdl description */
static int patlimit_flag = 0;            /*nbr de patterns dans une sequence */

/****************************************************************************/
/****************************************************************************/
/* Aide sur la ligne de commande */
static void usage() 
{
fprintf(stdout,"\
%s version %s :\n\
   %s   --help\n\
   %s   [ -hvcxeb ]  [ -p [all|<number>] ]  [ <description files> ]\n\
           [ <source.PAT> ]  [ [-fs] <destination.PAT> ]\n\
",PROGRAM_NAME,PROGRAM_VERSION,PROGRAM_NAME,PROGRAM_NAME);
}



/****************************************************************************/
static void help() 
{
fprintf(stdout,"\
%s version %s :\n\
   %s   [ -hvcxeb ]  [ -p [all|<number>] ]  [ <description files> ]\n\
           [ <source.PAT> ]  [ [-fs] <destination.PAT> ]\n\
  -h,--help\tDisplay this current message.\n\
  -v,--verbose\tDisplay all warnings and actions.\n\
  -p,--pattern\tMust be followed by the <number> (or \"all\") of patterns %s\n\
\t\twill treat in one sequence. If you have memory problems put the\n\
\t\tpatterns number lower than the default value %d. You can also\n\
\t\traise it up.\n\
  -s,--serial\tKind of patterns to be saved. Take the boundary scan serial\n\
\t\tform. Beware destination file size is many times source size!\n\
  -f,--functionnal\tKind of patterns to be saved. Keep the functionnal form of the\n\
\t\tpattern source file.\n\
  -c,--check\tCheck the boundary scan hardware. It can be followed by a\n\
\t\tdescription to compare the file with the hardware.\n\
  -e,--emulbs,-b,--bsdl\n\
\t\tTraduce functionnal patterns into boundary scan patterns. These\n\
\t\toptions need both functionnal pattern file for <source> and\n\
\t\toptionnaly a <destination> file to keep results. The difference\n\
\t\tis in <description files>. If there is an EMULBS31 interface\n\
\t\tcard on the DUT, you must use --emulbs option. If you don't have\n\
\t\tsuch card, put --bsdl option.\n\
\t\t\t--emulbs <emulbs_connexions> <pga_connexions>\n\
\t\t\t--bsdl   <description.BSDL>\n\
\t\tsee manual page for more information.\n\
  -x,--execute\tSend boundary scan patterns to the DUT hardware. It can be\n\
\t\tcombinated with -e or -b options.
",PROGRAM_NAME,PROGRAM_VERSION,PROGRAM_NAME,PROGRAM_NAME,PAT_LIMIT);
}



/****************************************************************************/
int    main(int argc, char *argv[]) 
{
unsigned int pat_limit=PAT_LIMIT;
int option_index=0;
extern char *optarg;
char opt;
char *sce=NULL,*destSRC=NULL,*destBS=NULL,*bsdl=NULL,*emu=NULL,*pga=NULL;
struct option long_options[] =
{    {"bsdl"       , no_argument      , NULL, 'b'},
     {"emulbs"     , no_argument      , NULL, 'e'},
     {"verbose"    , no_argument      , NULL, 'v'},
     {"pattern"    , required_argument, NULL, 'p'},
     {"execute"    , no_argument      , NULL, 'x'},
     {"check"      , no_argument      , NULL, 'c'},
     {"serial"     , required_argument, NULL, 's'},
     {"functionnal", required_argument, NULL, 'k'},
     {"help"       , no_argument      , NULL, 'h'}};


/****initialisation environnement****/
  mbkenv();
  initializeBdd(SMALL_BDD);                                     /*SMALL_BDD=0*/
  error_signal_handler();                                     /*interruptions*/
  alliancebanner_with_authors("PcBs", PROGRAM_VERSION, 
                              "PC/Boundary-Scan Tester Platform", 
                "2000", ALLIANCE_VERSION,
                "Ana ABRIL, Franois DONNET, Eric MECHIN, Philippe OLEK");


/****RECHERCHE DES OPTIONS****/
  while ((opt=getopt_long (argc, argv,"hvp:cbexs:f:",long_options,&option_index)) != EOF)/*cf. getopt.h*/  
       switch (opt)
       {
/*verbose*/	    
       case 'v': 
	  if (verbose_flag) {
	       fprintf(stdout,"'-v' option already used!\n");
	       usage();pcbs_exit(0);};
	  verbose_flag=1;
	  break;
/*check mode with(out) bsdl*/
       case 'c':
	  if (check_flag) {
	       fprintf(stdout,"'-c' option already used!\n");
	       usage();pcbs_exit(0);}
	  check_flag=1;
	  break;
/*number of patterns in sequence with number , without =all*/
       case 'p': 
	  if (patlimit_flag) {
	       fprintf(stdout,"'-p' option already used!\n");
	       usage();pcbs_exit(0);}
	  patlimit_flag=1;
          if (optarg==NULL || !strcmp("=all",optarg) || !strcmp("all",optarg))
	       pat_limit=0;
	  else if (optarg[0]=='=') pat_limit=atoi((char*)optarg+1);
	  else pat_limit=atoi(optarg);
	  break;
/*kind of pattern to be saved*/
       case 's': 
	  if (savePatBS_flag) {
	       fprintf(stdout,"'-s' option already used!\n");
	       usage();pcbs_exit(0);}
	  savePatBS_flag=1;
	  if (optarg!=NULL) destBS=optarg;
          if (savePatSRC_flag && !strcmp(destSRC,destBS)) {
	    fprintf(stdout,"same name %s for two destination files!\n",destBS);
	    usage();pcbs_exit(0);}	      
	  break;
/*kind of pattern to be saved*/
       case 'f': 
	  if (savePatSRC_flag) {
	       fprintf(stdout,"'-f' option already used!\n");
	       usage();pcbs_exit(0);}
	  savePatSRC_flag=1;
	  if (optarg!=NULL) destSRC=optarg;
          if (savePatBS_flag && !strcmp(destSRC,destBS)) {
	    fprintf(stdout,"same name %s for two destination files!\n",destBS);
	    usage();pcbs_exit(0);}	      
	  break;
/*execution hardware*/
       case 'x':
	  if (execute_flag) {
	       fprintf(stdout,"'-x' option already used!\n");
	       usage();pcbs_exit(0);}
	  execute_flag=1;
	  break;
/*emulbs description for traduction*/
       case 'e': 
	  if (emulbs_flag) {
	       fprintf(stdout,"'-e' option already used!\n");
	       usage();pcbs_exit(0);}
	  emulbs_flag=1;
	  if (bsdl_flag)  {
	       fprintf(stderr,"'-e' option doesn't match with '-b'!\n");
	       usage();pcbs_exit(0);}
	  break;
/*description bsdl*/
       case 'b':  
	  if (bsdl_flag) {
	       fprintf(stdout,"'-b' option already used!\n");
	       usage();pcbs_exit(0);}
	  bsdl_flag=1;
	  if (emulbs_flag)  {
	       fprintf(stderr,"'-b' option doesn't match with '-e'!\n");
	       usage();pcbs_exit(0);}
	  break;
/*description bsdl*/
       case 'h': help();pcbs_exit(0);break;
/*erreur*/
       case '?':
       default:  usage (); pcbs_exit(0);  
       }



/****COHERENCE****/
/*impossible produire patterns paralleles corriges sans hardware*/
  if (savePatSRC_flag && !execute_flag) {
	       fprintf(stderr,"'-f' option needs '-x'!\n");
	       usage();pcbs_exit(0);}
/*impossible produire les patterns paralleles sans ceux d'origine*/
  if (savePatSRC_flag && !emulbs_flag && !bsdl_flag) {
	       fprintf(stderr,"'-f' option needs '-e' or '-b'!\n");
	       usage();pcbs_exit(0);}
/*emulation*/
  if (emulbs_flag) {
       /*sources*/
       if (optind < argc) emu=argv[optind++];
       else {
	    fprintf(stderr,"'-e' option needs two description files!\n");
	    usage();pcbs_exit(0);}
       if (optind < argc) pga=argv[optind++];
       else {
	    fprintf(stderr,"'-e' option needs one description file more!\n");
	    usage();pcbs_exit(0);}
       if (optind < argc) sce=argv[optind++];
       else {
	    fprintf(stderr,"'-e' option needs pattern source!\n");
	    usage();pcbs_exit(0);}
       /*destination optionnelle si...*/
       if (execute_flag && !savePatSRC_flag && optind < argc) 
            {destSRC=argv[optind++];savePatSRC_flag=1;}
       if (!savePatBS_flag && optind < argc) 
            {destBS=argv[optind++];savePatBS_flag=1;}
       if (!check_flag&&!execute_flag && !savePatSRC_flag && !savePatBS_flag) {
	    fprintf(stderr,"'-e' option needs a destination!\n");
	    usage();pcbs_exit(0);}
       /*trop de parametres*/
       if (optind < argc) {
	    fprintf(stderr,"too much parameters!\n");
	    usage();pcbs_exit(0);}
  }
/*bsdl*/
  else if (bsdl_flag) {
       /*sources*/
       if (optind < argc) bsdl=argv[optind++];
       else {
	    fprintf(stderr,"'-b' option needs a BSDL description!\n");
	    usage();pcbs_exit(0);}
       if (optind < argc) sce=argv[optind++];
       else {
	    fprintf(stderr,"'-b' option needs pattern source!\n");
	    usage();pcbs_exit(0);}
       /*destination optionnelle si...*/
       if (execute_flag && !savePatSRC_flag && optind < argc) 
            {destSRC=argv[optind++];savePatSRC_flag=1;}
       if (!savePatBS_flag && optind < argc) 
            {destBS=argv[optind++];savePatBS_flag=1;}
       if (!execute_flag && !savePatSRC_flag && !savePatBS_flag) {
	    fprintf(stderr,"'-b' option needs a destination!\n");
	    usage();pcbs_exit(0);}
       /*trop de parametres*/
       if (optind < argc) {
	    fprintf(stderr,"too much parameters!\n");
	    usage();pcbs_exit(0);}
  }
/*execution*/
  else if (execute_flag) {
       /*source*/
       if (optind < argc) sce=argv[optind++];
       else {
	    fprintf(stderr,"'-x' option needs pattern source!\n");
	    usage();pcbs_exit(0);}
       /*destination optionnelle*/
       if ((emulbs_flag||bsdl_flag) && !savePatSRC_flag && optind < argc) 
            {destSRC=argv[optind++];savePatSRC_flag=1;}
       if (!savePatBS_flag && optind < argc) 
            {destBS=argv[optind++];savePatBS_flag=1;}
       if (!execute_flag && !savePatSRC_flag && !savePatSRC_flag) {
	    fprintf(stderr,"'-b' option needs a destination!\n");
	    usage();pcbs_exit(0);}
       /*trop de parametres*/
       if (optind < argc) {
	    fprintf(stderr,"too much parameters!\n");
	    usage();pcbs_exit(0);}
  }
/*check*/
  else if (check_flag) {
       /*source optionnelle*/
       if (bsdl_flag && optind < argc) bsdl=argv[optind++];
       else if (emulbs_flag && optind < argc) {
	    emu=argv[optind++];
	    if (optind < argc) pga=argv[optind++];
	    else {
		 fprintf(stderr,"One description file is missing!\n");
		 usage();pcbs_exit(0);}
       }
       /*trop de parametres*/
       if (optind < argc) {
	    fprintf(stderr,"too much parameters!\n");usage();pcbs_exit(0);}
  }
/*aucune option*/
  else {usage();pcbs_exit(0);}

/*meme source et destination*/
  if (destSRC!=NULL && destBS!=NULL && !strcmp(destSRC,destBS)) {
       fprintf(stderr,"%s represents two destination files!\n",destSRC);
       usage();pcbs_exit(0);}
  if (destSRC!=NULL && sce!=NULL && !strcmp(destSRC,sce)) {
       fprintf(stderr,"%s represents a source and a destination file!\n",sce);
       usage();pcbs_exit(0);}
  if (sce!=NULL && destBS!=NULL && !strcmp(sce,destBS)) {
       fprintf(stderr,"%s represents a source and a destination file!\n",sce);
       usage();pcbs_exit(0);}




/****traitement****/
  /* Chargement de la  description du boundary scan */
  if (bsdl_flag && ReadBSDL(bsdl)) pcbs_exit(1);
  if (emulbs_flag && description_cartes(emu,pga)<0) pcbs_exit(1);
  if ((emulbs_flag || bsdl_flag) && VerificationsInfos()) pcbs_exit(1);
  
  /*verification hardware*/
  if (check_flag || execute_flag) {
       fprintf(stdout,"Checking DUT connected to %s\n",
	       (char*) current_lpscan_device());
       if (check_mode()) pcbs_exit(1);
  }

  /*sans traduction*/
  if (execute_flag && !emulbs_flag && !bsdl_flag) 
       {if (send_pat_file(sce,destBS,pat_limit)) pcbs_exit(1);pcbs_exit(0);}

  /*avec traduction*/
  if (execute_flag) open_port();
  if ((emulbs_flag || bsdl_flag) && traduire(sce,destSRC,destBS,pat_limit))
       pcbs_exit(1);                /*traduction*/
  if (execute_flag) close_port();
pcbs_exit(0);


/****impossible d'arriver ici****/
fprintf(stderr,"!!!!!!!!!!! BUG (File %s,line %d)\n",__FILE__,__LINE__);
return 1;
}


/*****************************************************************************/
/******************************** END OF FILE ********************************/
/*****************************************************************************/





