
/* ###--------------------------------------------------------------### */
/* 									*/
/* file		: prb_addprbsup.c					*/
/* date		: Jan  20 1998						*/
/* version	: v107							*/
/* authors	: Julien DUNOYER					*/
/* content	: low-level function					*/
/*									*/
/* ###--------------------------------------------------------------### */

#include <stdio.h>
#include MUT_H
#include LOG_H
#include "beh.h"
#include PRB_H

/* ###--------------------------------------------------------------### */
/* function	: prb_addprbsup						*/
/* description	: create a PRBSUP structure at the top of the list	*/
/* called func.	: namealloc, mbkalloc					*/
/* ###--------------------------------------------------------------### */

struct prbsup *prb_addprbsup ( bdd_expr, abl_expr, var_list, der_list, ddr_list)

struct node  *bdd_expr;
struct chain *abl_expr;
struct chain *var_list;
struct beder *der_list;
struct beder *ddr_list;

  {
  struct prbsup *ptsup;


  ptsup           = (struct prbsup *) mbkalloc (sizeof(struct prbsup));
  ptsup->BDD      = bdd_expr;
  ptsup->ABL      = abl_expr;
  ptsup->VARLIST  = var_list;
  ptsup->DERIVATE = der_list;
  ptsup->DERDEDER = ddr_list;
  ptsup->FLAG     = DEF_PRB_DEFGATE;
  return (ptsup);
  }
