
/* ###--------------------------------------------------------------### */
/* file		: prb_makprbsup.c					*/
/* date		: Jan  10 1998						*/
/* version	: v107							*/
/* authors	: Julien DUNOYER					*/
/* description	: high level function					*/
/* ###--------------------------------------------------------------### */

#include <stdio.h>
#include MUT_H
#include LOG_H
#include "beh.h"
#include "bhl.h"
#include PRB_H

/* ###--------------------------------------------------------------### */
/* function     : prb_makprbsup						*/
/* description  : add an empty PRBSUP structure for each expression	*/
/* called func. : prb_addprbsup	 					*/
/* ###--------------------------------------------------------------### */

void prb_makprbsup (pt_befig)

struct befig *pt_befig;

  {
  struct beaux  *pt_beaux;
  struct berin  *pt_berin;
  struct beout  *pt_beout;
  struct bebus  *pt_bebus;
  struct bebux  *pt_bebux;
  struct bereg  *pt_bereg;
  struct bemsg  *pt_bemsg;
  struct binode *pt_binod;
  struct biabl  *pt_biabl;

	/* ###------------------------------------------------------### */
	/*   simple output ports					*/
	/* ###------------------------------------------------------### */

  pt_beout = pt_befig->BEOUT;
  while (pt_beout != NULL)
     {
     PRB_SUPERNODE(pt_beout->NODE)  = prb_addprbsup (NULL, NULL, NULL, NULL, NULL);
     pt_beout       = pt_beout->NEXT;
     }

	/* ###------------------------------------------------------### */
	/*   bussed ouput ports						*/
	/* ###------------------------------------------------------### */

  pt_bebus = pt_befig->BEBUS;
  while (pt_bebus != NULL)
     {
     pt_binod = pt_bebus->BINODE;
     while (pt_binod != NULL)
       {
       PRB_SUPERNODE(pt_binod->CNDNODE) = prb_addprbsup (NULL, NULL, NULL, NULL, NULL);
       PRB_SUPERNODE(pt_binod->VALNODE) = prb_addprbsup (NULL, NULL, NULL, NULL, NULL);

       pt_binod          = pt_binod->NEXT;
       }
     pt_bebus = pt_bebus->NEXT;
     }

	/* ###------------------------------------------------------### */
	/*   internal bussed signals					*/
	/* ###------------------------------------------------------### */

  pt_bebux = pt_befig->BEBUX;
  while (pt_bebux != NULL)
     {
     pt_binod = pt_bebux->BINODE;
     while (pt_binod != NULL)
       {
       PRB_SUPERNODE(pt_binod->CNDNODE) = prb_addprbsup (NULL, NULL, NULL, NULL, NULL);
       PRB_SUPERNODE(pt_binod->VALNODE) = prb_addprbsup (NULL, NULL, NULL, NULL, NULL);

       pt_binod          = pt_binod->NEXT;
       }
     pt_bebux = pt_bebux->NEXT;
     }

	/* ###------------------------------------------------------### */
	/*   internal registers						*/
	/* ###------------------------------------------------------### */

  pt_bereg = pt_befig->BEREG;
  while (pt_bereg != NULL)
     {
     pt_binod = pt_bereg->BINODE;
     while (pt_binod != NULL)
       {
       PRB_SUPERNODE(pt_binod->CNDNODE) = prb_addprbsup (NULL, NULL, NULL, NULL, NULL);
       PRB_SUPERNODE(pt_binod->VALNODE) = prb_addprbsup (NULL, NULL, NULL, NULL, NULL);

       pt_binod          = pt_binod->NEXT;
       }
     pt_bereg = pt_bereg->NEXT;
     }

	/* ###------------------------------------------------------### */
	/*   internal simple signals					*/
	/* ###------------------------------------------------------### */
    
  pt_beaux = pt_befig->BEAUX;
  while (pt_beaux != NULL)
     {
     PRB_SUPERNODE(pt_beaux->NODE)  = prb_addprbsup (NULL, NULL, NULL, NULL, NULL);
     pt_beaux       = pt_beaux->NEXT;
     }

	/* ###------------------------------------------------------### */
	/*   internal delayed signals					*/
	/* ###------------------------------------------------------### */

  pt_beaux = pt_befig->BEDLY;
  while (pt_beaux != NULL)
     {
     PRB_SUPERNODE(pt_beaux->NODE)  = prb_addprbsup (NULL, NULL, NULL, NULL, NULL);
     pt_beaux       = pt_beaux->NEXT;
     }

	/* ###------------------------------------------------------### */
	/*   assertions							*/
	/* ###------------------------------------------------------### */

  pt_bemsg = pt_befig->BEMSG;
  while (pt_bemsg != NULL)
     {
     PRB_SUPERNODE(pt_bemsg->NODE)  = prb_addprbsup (NULL, NULL, NULL, NULL, NULL);
     pt_bemsg       = pt_bemsg->NEXT;
     }
  }
