/* ###--------------------------------------------------------------### */
/*                                                                      */
/* file         : prb_randprbseq.c                                      */
/* date         : Jun  1 1994                                           */
/* version      : v1.00                                                 */
/* author       : DUNOYER julien                                        */
/* description  : This file contains functions relative to the          */
/*                generation of random prb sequences :                  */
/*                prb_randprbseq                                        */
/* ###--------------------------------------------------------------### */

#include <stdio.h>
#include <sys/time.h>

#include MUT_H
#include LOG_H
#include MLO_H
#include "beh.h"
#include "bhl.h"
#include PRB_H
#include GSS_H

/* ###--------------------------------------------------------------### */
/*                       defines                                        */
/*                       static variables declaration                   */
/*                       externals                                      */
/* ###--------------------------------------------------------------### */

#define DEF_RAND_BASE  2147483647

/* ###--------------------------------------------------------------### */
/* function	: prb_randprbseq					*/
/* description	: generate randomly a prb sequence			*/
/* called func.	: none							*/
/* ###--------------------------------------------------------------### */
struct prbseq  *prb_randprbseq (seqname, ptlofig, head_befig)

char              *seqname;
struct lofig      *ptlofig;
struct befig      *head_befig;
  {
  struct prbseq     *pt_prbseq = NULL;
  struct prbevt     *pt_prbevt = NULL;
  struct bebux      *ptbebux ;
  struct bereg      *ptbereg ;
  struct befig      *ptbefig ;
  struct loins      *ptloins ;
  struct losig      *ptlosig ;
  struct locon      *ptlocon ;
  char              *name ;
  char              *insname ;

  pt_prbseq = prb_addprbseq(seqname);

  if (ptlofig != NULL)
    {
    ptlocon  = ptlofig->LOCON;
    while (ptlocon != NULL)
      {
      ptlosig = ptlocon->SIG;

      name = getsigname(ptlosig);

      pt_prbevt = prb_addprbevt( (struct prbevt *) pt_prbevt,
                                          (char *) name,
                                          (float ) rand () / DEF_RAND_BASE,
                                          (float ) rand () / DEF_RAND_BASE,
                                          (float ) rand () / DEF_RAND_BASE,
                                          (char  ) DEF_PRB_UNKNOWN,
                                          (char  ) DEF_PRB_UNKNOWN);

      switch (ptlocon->DIRECTION )
        {
        case 'I' :
          pt_prbevt->MODE = DEF_PRB_IN;
          break;
        case 'O' :
          pt_prbevt->MODE = DEF_PRB_OUT;
          break;
        case 'B' :
          pt_prbevt->MODE = DEF_PRB_INOUT;
          break;
        case 'Z' :
          pt_prbevt->MODE = DEF_PRB_TRISTATE;
          break;
        case 'T' :
          pt_prbevt->MODE = DEF_PRB_TRANSC;
          break;
        default  :
          pt_prbevt->MODE = DEF_PRB_PORT;
          break;
        }

      ptlocon  = ptlocon->NEXT;
      }

    ptloins = ptlofig->LOINS;
    while ( ptloins != NULL)
      {
      insname = ptloins->INSNAME;

      ptbefig = head_befig;
      while (ptbefig != NULL)
        {
        if (ptbefig->NAME == ptloins->FIGNAME)
          {
          break;
          }
        ptbefig = ptbefig->NEXT;
        }

      if (ptbefig == NULL)
        {
        prb_toolbug (4, NULL, 0);
        }

/*------------------------------
      ptbebux  = ptbefig->BEBUX;
      while (ptbebux != NULL)
        {
        name = concatname (insname, ptbebux->NAME);

        pt_prbevt = prb_addprbevt( (struct prbevt *) pt_prbevt,
                                            (char *) name,
                                            (float ) rand () / DEF_RAND_BASE,
                                            (float ) rand () / DEF_RAND_BASE,
                                            (float ) rand () / DEF_RAND_BASE,
                                            (char  ) DEF_PRB_TRISTATE,
                                            (char  ) DEF_PRB_UNKNOWN);

        ptbebux  = ptbebux->NEXT;
        }
------------------------------*/
 
      ptbereg  = ptbefig->BEREG;
      while (ptbereg != NULL)
        {
        name = concatname (insname, ptbereg->NAME);

        pt_prbevt = prb_addprbevt( (struct prbevt *) pt_prbevt,
                                            (char *) name,
                                            (float ) rand () / DEF_RAND_BASE,
                                            (float ) rand () / DEF_RAND_BASE,
                                            (float ) rand () / DEF_RAND_BASE,
                                            (char  ) DEF_PRB_REGISTER,
                                            (char  ) DEF_PRB_UNKNOWN);

        ptbereg  = ptbereg->NEXT;
        }
      ptloins = ptloins->NEXT;
      }
    }
  pt_prbseq->PRBEVT = (struct prbevt *)reverse((struct chain *)pt_prbevt);

  return (pt_prbseq);
  }

