#include <stdio.h>

#include MUT_H
#include PRB_H
#include "prb_tab.h"

/* ###--------------------------------------------------------------### */
/*			variables declaration				*/
/*			external declaration				*/
/* ###--------------------------------------------------------------### */

static short			 TAB_IDX = DEF_PRB_TABBASE;
static char			**TAB ;

extern int 			PRB_LINNUM;

/* ###--------------------------------------------------------------### */
/* function	: creattab						*/
/* description	: create a TAB stack 					*/
/* called func.	: mbkalloc						*/
/* ###--------------------------------------------------------------### */

void creattab ()

{
  TAB = (char **) mbkalloc (DEF_PRB_TABSIZE*sizeof(char *));
}

/* ###--------------------------------------------------------------### */
/* function	: freetab						*/
/* description	: free a TAB stack 					*/
/* called func.	: mbkfree						*/
/* ###--------------------------------------------------------------### */

void freetab()
{
  mbkfree (TAB);
}

/* ###--------------------------------------------------------------### */
/* function	: flushtab						*/
/* description	: flush a TAB stack 					*/
/* called func.	: mbkfree						*/
/* ###--------------------------------------------------------------### */

void flushtab()
{
   TAB_IDX = DEF_PRB_TABBASE;
}

/* ###--------------------------------------------------------------### */
/* function	: pshtab						*/
/* description	: push a name on a TAB stack 				*/
/*		  return 0 if ok 1 else					*/
/* called func.	: prb_error						*/
/* ###--------------------------------------------------------------### */

int pshtab (name)
 char *name;

  {
  int err = 0;

  if (TAB_IDX >= DEF_PRB_TABSIZE)
    err = prb_error (208, NULL, 0.0, ' ', PRB_LINNUM);
  else
    TAB [TAB_IDX++] = name;

  return (err);
  }

/* ###--------------------------------------------------------------### */
/* function	: poptab						*/
/* description	: pop a name from a TAB stack print error only if asked */
/*		  return 0 if ok 1 else					*/
/* called func.	: prb_error						*/
/* ###--------------------------------------------------------------### */
int poptab (ptname, flag)
 char **ptname;
 char flag;

{
  int err = 0;

  if (TAB_IDX <= DEF_PRB_TABBASE)
  {
    if ( flag != DEF_PRB_NOERROR )
       err = prb_error (207, NULL, 0.0, ' ', PRB_LINNUM);
    else 
       err++ ;
  }
  else
  {
     TAB_IDX--;
    *ptname = TAB [TAB_IDX];
  }
     
  return (err);
}
