/*
 * This file is part of the Alliance CAD System
 * Copyright (C) Laboratoire LIP6 - Dpartement ASIM
 * Universite Pierre et Marie Curie
 * 
 * Home page          : http://www-asim.lip6.fr/alliance/
 * E-mail support     : mailto:alliance-support@asim.lip6.fr
 * 
 * This progam is  free software; you can redistribute it  and/or modify it
 * under the  terms of the GNU  General Public License as  published by the
 * Free Software Foundation;  either version 2 of the License,  or (at your
 * option) any later version.
 * 
 * Alliance VLSI  CAD System  is distributed  in the hope  that it  will be
 * useful, but WITHOUT  ANY WARRANTY; without even the  implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details.
 * 
 * You should have received a copy  of the GNU General Public License along
 * with the GNU C Library; see the  file COPYING. If not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include "genlib.h"

rsa_int(n,cin,cout,over,overn,csa,addsub,
        deci,stretch,stretch2,msb0,name)
int n,cin,cout,over,overn,csa,addsub,
    deci,stretch,stretch2,msb0;
char *name;
{
 int  d=msb0?0:n-1;
 int  f=msb0?n-1:0;

 char *ncout,*nover,*na,*nb,*nc,*ns,*nco;


   if ( stretch || stretch2 || deci )
      printf("Warning : options deci, stretch, stretch2 are not taken into account for logicalbox view\n");

   ncout=GENLIB_NAME("cout%s",(rsa_puiss(n-1)&1) ? "" : "_n");
   nover=GENLIB_NAME("over%s",(rsa_puiss(n-2)&1) ? "" : "_n");
      na=GENLIB_NAME( "a[%d:%d]",d,f);
      nb=GENLIB_NAME( "b[%d:%d]",d,f);
      nc=GENLIB_NAME( "c[%d:%d]",d,f);
      ns=GENLIB_NAME( "s[%d:%d]",d,f);
     nco=GENLIB_NAME("co[%d:%d]",d,f);

               GENLIB_DEF_LOFIG(name);
               GENLIB_LOCON(   na, IN,   na);
               GENLIB_LOCON(   nb, IN,   nb);
   if( csa )   GENLIB_LOCON(   nc, IN,   nc);
   if( cin )   GENLIB_LOCON("cin", IN,"cin");
   if(cout )   GENLIB_LOCON(  nco,OUT,  nco);
   if( csa )   GENLIB_LOCON("coc",OUT,"coc");
               GENLIB_LOCON(ncout,OUT,ncout);
   if( over | overn )
               GENLIB_LOCON(nover,OUT,nover);
               GENLIB_LOCON(   ns,OUT,   ns);
   if(addsub)  GENLIB_LOCON("sub", IN,"sub");
               GENLIB_LOCON("vdd", IN,"vdd");
               GENLIB_LOCON("vss", IN,"vss");
               GENLIB_SAVE_LOFIG();
}
