# /*------------------------------------------------------------\
# |                                                             |
# | Title      :       Parameters File for Xsch                 |
# |                                                             |
# | Author     :           Ludovic Jacomme                      |
# |                                                             |
# | Date       :             03.29.2000                         |
# |                                                             |
# \------------------------------------------------------------*/
# /*------------------------------------------------------------\
# |                                                             |
# |                           Unit                              |
# |                                                             |
# \------------------------------------------------------------*/

DEFINE XSCH_UNIT  64

# /*------------------------------------------------------------\
# |                                                             |
# |               Lower Grid Step in pixel by unit              |
# |                                                             |
# \------------------------------------------------------------*/

DEFINE XSCH_LOWER_GRID_STEP 50

# /*------------------------------------------------------------\
# |                                                             |
# |                        Xsch Color                           |
# |                                                             |
# \------------------------------------------------------------*/

DEFINE XSCH_CURSOR_COLOR_NAME      Black
DEFINE XSCH_BACKGROUND_COLOR_NAME  Black
DEFINE XSCH_FOREGROUND_COLOR_NAME  White
DEFINE XSCH_ACCEPT_COLOR_NAME      magenta
DEFINE XSCH_CONNECT_COLOR_NAME     magenta 

# /*------------------------------------------------------------\
# |                                                             |
# |                  Xsch Cursor Size in pixel                  |
# |                                                             |
# \------------------------------------------------------------*/

DEFINE XSCH_CURSOR_SIZE 10 

# /*------------------------------------------------------------\
# |                                                             |
# |                     Xsch Layer Color                        |
# |                                                             |
# \------------------------------------------------------------*/

TABLE XSCH_LAYER_NAME

  0   Gates           cyan              Black
  1   Inputs          red               Black
  2   Outputs         light_blue        Black
  3   Signals         yellow            Black
  4   Debug           spring_green      Black
  5   Layer_0         #0000ff           Black
  6   Layer_1         #0020ff           Black
  7   Layer_2         #0040ff           Black
  8   Layer_3         #0060ff           Black
  9   Layer_4         #0080ff           Black
 10   Layer_5         #00a0ff           Black
 11   Layer_6         #00c0ff           Black
 12   Layer_7         #00e0ff           Black
 13   Layer_8         #00ffff           Black
 14   Layer_9         #00ffe0           Black
 15   Layer_10        #00ffc0           Black
 16   Layer_11        #00ffa0           Black
 17   Layer_12        #00ff80           Black
 18   Layer_13        #00ff60           Black
 19   Layer_14        #00ff40           Black
 20   Layer_15        #00ff20           Black
 21   Layer_16        #00ff00           Black
 22   Layer_17        #20ff00           Black
 23   Layer_18        #40ff00           Black
 24   Layer_19        #60ff00           Black
 25   Layer_20        #80ff00           Black
 26   Layer_21        #a0ff00           Black
 27   Layer_22        #c0ff00           Black
 28   Layer_23        #e0ff00           Black
 29   Layer_24        #ffff00           Black
 30   Layer_25        #ffe000           Black
 31   Layer_26        #ffc000           Black
 32   Layer_27        #ffa000           Black
 33   Layer_28        #ff8000           Black
 34   Layer_29        #ff6000           Black
 35   Layer_30        #ff4000           Black
 36   Layer_31        #ff2000           Black
 37   Layer_32        #ff0000           Black

END 

# /*------------------------------------------------------------\
# |                                                             |
# |                     Xsch Icon Cell Buffer                   |
# |                                                             |
# \------------------------------------------------------------*/

TABLE XSCH_ICON_CELL_BUFFER

# model  inputs output not_in not_out

# SXLIB

  buf_x2 i  q 0 0
  buf_x4 i  q 0 0
  buf_x8 i  q 0 0

  inv_x1 i nq 0 1
  inv_x2 i nq 0 1
  inv_x4 i nq 0 1
  inv_x8 i nq 0 1

# SCLIB

  b1_y     i  t 0 0
  d1_y     i  t 0 0
  p1_y     i  t 0 0

  n1_y     i  f 0 1
  np1_y    i  f 0 1
  ndrv_y   i  f 0 1
  ndrvp_y  i  f 0 1

END

# /*------------------------------------------------------------\
# |                                                             |
# |                     Xsch Icon Cell And                      |
# |                                                             |
# \------------------------------------------------------------*/

TABLE XSCH_ICON_CELL_AND

# model  inputs output number_in not_in not_out

# SXLIB

  a2_x2   i0,i1         q  2 0 0
  a2_x4   i0,i1         q  2 0 0
  a3_x2   i0,i1,i2      q  3 0 0
  a3_x4   i0,i1,i2      q  3 0 0
  a4_x2   i0,i1,i2,i3   q  4 0 0
  a4_x4   i0,i1,i2,i3   q  4 0 0

  na2_x1   i0,i1        nq  2 0 1
  na2_x4   i0,i1        nq  2 0 1
  na3_x1   i0,i1,i2     nq  3 0 1
  na3_x4   i0,i1,i2     nq  3 0 1
  na4_x1   i0,i1,i2,i3  nq  4 0 1
  na4_x4   i0,i1,i2,i3  nq  4 0 1

  an12_x1  i0,i1         q  2 2 0
  an12_x4  i0,i1         q  2 2 0

# SCLIB

  a2_y     i0,i1         t 2 0 0
  a2p_y    i0,i1         t 2 0 0
  a3_y     i0,i1,i2      t 3 0 0
  a3p_y    i0,i1,i2      t 3 0 0
  a4_y     i0,i1,i2,i3   t 4 0 0
  a4p_y    i0,i1,i2,i3   t 4 0 0

  na2_y    i0,i1         f 2 0 1
  na2p_y   i0,i1         f 2 0 1
  na3_y    i0,i1,i2      f 3 0 1
  na3p_y   i0,i1,i2      f 3 0 1
  na4_y    i0,i1,i2,i3   f 4 0 1
  na4p_y   i0,i1,i2,i3   f 4 0 1

END

# /*------------------------------------------------------------\
# |                                                             |
# |                     Xsch Icon Cell Or                       |
# |                                                             |
# \------------------------------------------------------------*/

TABLE XSCH_ICON_CELL_OR 

# model  inputs output number_in not_in not_out

# SXLIB

  o2_x2   i0,i1         q  2 0 0
  o2_x4   i0,i1         q  2 0 0
  o3_x2   i0,i1,i2      q  3 0 0
  o3_x4   i0,i1,i2      q  3 0 0
  o4_x2   i0,i1,i2,i3   q  4 0 0
  o4_x4   i0,i1,i2,i3   q  4 0 0

  no2_x1   i0,i1        nq  2 0 1
  no2_x4   i0,i1        nq  2 0 1
  no3_x1   i0,i1,i2     nq  3 0 1
  no3_x4   i0,i1,i2     nq  3 0 1
  no4_x1   i0,i1,i2,i3  nq  4 0 1
  no4_x4   i0,i1,i2,i3  nq  4 0 1

  on12_x1  i0,i1         q  2 2 0
  on12_x4  i0,i1         q  2 2 0

# SCLIB

  o2_y     i0,i1         t 2 0 0
  op2_y    i0,i1         t 2 0 0
  o3_y     i0,i1,i2      t 3 0 0
  op3_y    i0,i1,i2      t 3 0 0

  no2_y    i0,i1         f 2 0 1
  nop2_y   i0,i1         f 2 0 1
  no3_y    i0,i1,i2      f 3 0 1
  nop3_y   i0,i1,i2      f 3 0 1


END

# /*------------------------------------------------------------\
# |                                                             |
# |                     Xsch Icon Cell Xor                      |
# |                                                             |
# \------------------------------------------------------------*/

TABLE XSCH_ICON_CELL_XOR 

# model  inputs output number_in not_in not_out

# SXLIB

  xr2_x1    i0,i1         q  2 0 0
  xr2_x4    i0,i1         q  2 0 0

  nxr2_x1   i0,i1        nq  2 0 1
  nxr2_x4   i0,i1        nq  2 0 1

# SCLIB

  xr2_y     i0,i1         t  2 0 0
  nxr2_y    i0,i1         f  2 0 1

END

# /*------------------------------------------------------------\
# |                                                             |
# |                     Xsch Icon Cell Tristate                 |
# |                                                             |
# \------------------------------------------------------------*/

TABLE XSCH_ICON_CELL_TRISTATE 

# model  inputs output not_in not_out

# SXLIB

  nts_x1    cmd,i        nq  0 1
  nts_x2    cmd,i        nq  0 1

  ts_x4     cmd,i         q  0 0
  ts_x8     cmd,i         q  0 0

# SCLIB

  ts_y      v,i           t  0 0
  tsp_y     v,i           t  0 0

  tsn_y     v,i           f  0 1
  
END

# /*------------------------------------------------------------\
# |                                                             |
# |                     Xsch Icon Cell Register                 |
# |                                                             |
# \------------------------------------------------------------*/

TABLE XSCH_ICON_CELL_REGISTER 

# model  inputs output number_in not_in clock_in not_out edge

# SXLIB

  sff1_x4   i,ck                      q 2 0 1  0  1
  sff2_x4   cmd,i0,i1,ck              q 4 0 1  0  1
  sff3_x4   cmd0,cmd1,i0,i1,i2,ck     q 6 0 1  0  1

# SCLIB

  ms_y      i,l                       t 2 0 1  0  2
  msdp2_y   di,ck                     t 2 0 1  0  2
  msdp4_y   di,ck                     t 2 0 1  0  2

  ms2dp2_y  di,si,se,ck               t 4 0 1  0  2
  ms2dp4_y  di,si,se,ck               t 4 0 1  0  2
  
END

# /*------------------------------------------------------------\
# |                                                             |
# |                     Xsch Icon Cell One                      |
# |                                                             |
# \------------------------------------------------------------*/

TABLE XSCH_ICON_CELL_CONSTANT 

# model  outputs number_out value

# SXLIB
  one_x0    q  1 1
  zero_x0  nq  1 0

# SCLIB
  one_y     t  1 1
  zero_y    f  1 0
  
END

# /*------------------------------------------------------------\
# |                                                             |
# |                     Xsch Icon Cell And_Or                   |
# |                                                             |
# \------------------------------------------------------------*/

TABLE XSCH_ICON_CELL_ANDOR 

# model      inputs  output number_in  not_in not_out

# SXLIB

  ao22_x2    i0,i1,i2     q  3          0     0
  ao22_x4    i0,i1,i2     q  3          0     0
  ao2o22_x2  i0,i1,i2,i3  q  4          0     0
  ao2o22_x4  i0,i1,i2,i3  q  4          0     0
                          
  nao22_x1   i0,i1,i2    nq  3          0     1
  nao22_x4   i0,i1,i2    nq  3          0     1
  nao2o22_x1 i0,i1,i2,i3 nq  4          0     1
  nao2o22_x4 i0,i1,i2,i3 nq  4          0     1

# SCLIB

  mx2_y      i0,l0,i1,l1              t  4   0   0
  mx2p_y     i0,l0,i1,l1              t  4   0   0
  mx3_y      i0,l0,i1,l1,i2,l2        t  6   0   0
  mx4_y      i0,l0,i1,l1,i2,l2,i3,l3  t  8   0   0
  nmx2_y     j0,i0,j1,i1              t  4   0   1
  nao3_y     i0,i1,i2                 f  3   0   1
  
END

# /*------------------------------------------------------------\
# |                                                             |
# |                     Xsch Icon Cell Or_And                   |
# |                                                             |
# \------------------------------------------------------------*/

TABLE XSCH_ICON_CELL_ORAND 

# model      inputs  output number_in  not_in   not_out

# SXLIB

  noa22_x1         i0,i1,i2                 nq  3  0 1
  noa22_x4         i0,i1,i2                 nq  3  0 1
  noa2a22_x1       i0,i1,i2,i3              nq  4  0 1
  noa2a22_x4       i0,i1,i2,i3              nq  4  0 1
  noa2a2a23_x1     i0,i1,i2,i3,i4,i5        nq  6  0 1
  noa2a2a23_x4     i0,i1,i2,i3,i4,i5        nq  6  0 1
  noa2a2a2a24_x1   i0,i1,i2,i3,i4,i5,i6,i7  nq  8  0 1
  noa2a2a2a24_x4   i0,i1,i2,i3,i4,i5,i6,i7  nq  8  0 1

  oa22_x2          i0,i1,i2                  q  3  0 1
  oa22_x4          i0,i1,i2                  q  3  0 1
  oa2a22_x2        i0,i1,i2,i3               q  4  0 1
  oa2a22_x4        i0,i1,i2,i3               q  4  0 1
  oa2a2a23_x2      i0,i1,i2,i3,i4,i5         q  6  0 1
  oa2a2a23_x4      i0,i1,i2,i3,i4,i5         q  6  0 1
  oa2a2a2a24_x2    i0,i1,i2,i3,i4,i5,i6,i7   q  8  0 1
  oa2a2a2a24_x4    i0,i1,i2,i3,i4,i5,i6,i7   q  8  0 1


# SCLIB

   noa3_y          i0,i1,i2                  f  3  0 1
   annup_y         i1,i2,i3,i4               f  4  0 1

END

# /*------------------------------------------------------------\
# |                                                             |
# |                     Xsch Icon Cell Mux                      |
# |                                                             |
# \------------------------------------------------------------*/

TABLE XSCH_ICON_CELL_MUX 

# model  inputs               output number_sel number_in not_in not_out
                              
# SXLIB                       
                              
  mx2_x2 cmd,i0,i1            q      1          2         0      0
  mx2_x4 cmd,i0,i1            q      1          2         0      0
                              
  mx3_x2 cmd0,cmd1,i0,i1,i2   q      2          3         0      0
  mx3_x4 cmd0,cmd1,i0,i1,i2   q      2          3         0      0

  nmx2_x1 cmd,i0,i1          nq      1          2         0      1
  nmx2_x4 cmd,i0,i1          nq      1          2         0      1
                             
  nmx3_x1 cmd0,cmd1,i0,i1,i2 nq      2          3         0      1
  nmx3_x4 cmd0,cmd1,i0,i1,i2 nq      2          3         0      1

END
