/*
 *               ,,,
 *              (o o)
 * ####=====oOO--(_)--OOO=========================================####
 * ##                                                               ##
 * ##   This file is part of FPT : A Formal Proof Toolkit           ##
 * ##   (C) 1996, MASI, CAO-VLSI Team                               ##
 * ##                                                               ##
 * ##   File            :  fpt_debug.c                              ##
 * ##   Author          :  Olivier SIROL                            ##
 * ##   Date            :  Jun 1996                                 ##
 * ##                                                               ##
 * ##   E-mail support  :  cao-vlsi@masi.ibp.fr                     ##
 * ##                                                               ##
 * ####===========================================================####
 *
 *
 */

#ident "$Id: fpt_debug.c,v 1.16 1997/05/23 14:27:36 sirol Exp $"


/*
 * ####===========================================================####
 * ##                                                               ##
 * ##                         Include Files                         ##
 * ##                                                               ##
 * ####===========================================================####
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include MUT_H
#include AUT_H
#include ABL_H
#include BDD_H
#include LOG_H
#include BEH_H
#include BVL_H

#include "fpt_public.h"



/*
 * ####===========================================================####
 * ##                                                               ##
 * ##                           Constants                           ##
 * ##                                                               ##
 * ####===========================================================####
 */
/*
 * ####===========================================================####
 * ##                                                               ##
 * ##                             Types                             ##
 * ##                                                               ##
 * ####===========================================================####
 */
/*
 * ####===========================================================####
 * ##                                                               ##
 * ##                           Variables                           ##
 * ##                                                               ##
 * ####===========================================================####
 */


/*
 * ####===========================================================####
 * ##                                                               ##
 * ##                           Functions                           ##
 * ##                                                               ##
 * ####===========================================================####
 */


/*================================================================####
 * Affichage befig (debug)
 *     
 */

void
FptAff (ptbefig)
     struct befig *ptbefig;
{

  bepor_list *ptbepor;
  berin_list *ptberin;
  bereg_list *ptbereg;
  beout_list *ptbeout;
  beaux_list *ptbeaux;
  bebus_list *ptbebus;
  bebux_list *ptbebux;



  displayfptverbose ("\n%s befig :\n", ptbefig->NAME);

  displayfptverbose ("################################# BEPOR list\n");
  for (ptbepor = ptbefig->BEPOR;
       ptbepor;
       ptbepor = ptbepor->NEXT)
    {
      displayfptverbose ("BEPOR : %s, \t dir : %c, \t type : %c\n",
			 ptbepor->NAME, ptbepor->DIRECTION, ptbepor->TYPE);
    }

  displayfptverbose ("################################# BERIN list\n");
  for (ptberin = ptbefig->BERIN;
       ptberin;
       ptberin = ptberin->NEXT)
    {
      displayfptverbose ("BERIN : %s\n", ptberin->NAME);
    }

  displayfptverbose ("################################# BEOUT list\n");
  for (ptbeout = ptbefig->BEOUT;
       ptbeout;
       ptbeout = ptbeout->NEXT)
    {
      displayfptverbose ("BEOUT : %s\n", ptbeout->NAME);
    }

  displayfptverbose ("################################# BEREG list\n");
  for (ptbereg = ptbefig->BEREG;
       ptbereg;
       ptbereg = ptbereg->NEXT)
    {
      displayfptverbose ("BEREG : %s\n", ptbereg->NAME);
    }

  displayfptverbose ("################################# BEAUX list\n");
  for (ptbeaux = ptbefig->BEAUX;
       ptbeaux;
       ptbeaux = ptbeaux->NEXT)
    {
      displayfptverbose ("BEAUX : %s\n", ptbeaux->NAME);
    }

  displayfptverbose ("################################# BEBUS list\n");
  for (ptbebus = ptbefig->BEBUS;
       ptbebus;
       ptbebus = ptbebus->NEXT)
    {
      displayfptverbose ("BEBUS : %s\n", ptbebus->NAME);
    }

  displayfptverbose ("################################# BEBUX list\n");
  for (ptbebux = ptbefig->BEBUX;
       ptbebux;
       ptbebux = ptbebux->NEXT)
    {
      displayfptverbose ("BEBUX : %s\n", ptbebux->NAME);
    }

  displayfptverbose ("################################# BEDLY list\n");
  for (ptbeaux = ptbefig->BEDLY;
       ptbeaux;
       ptbeaux = ptbeaux->NEXT)
    {
      displayfptverbose ("BEDLY : %s\n", ptbeaux->NAME);
    }

  displayfptverbose ("\n\n");
}




/*================================================================####
 * fptViewBddNode
 *
 */

void
fptViewBddNode (BddNode)

     bddnode *BddNode;
{
  chain_list *Expr;

  Expr = convertbddcircuitabl ((bddcircuit *) 0, BddNode);
  viewablexpr (Expr, ABL_VIEW_VHDL);
  delablexpr (Expr);

  fprintf (stdout, "\n");
}



/*================================================================####
 * View Transition Function
 *
 */

void
viewfpttransfunc (TransFunc)

     fpttransfunc *TransFunc;
{
  fptvarfunc *VarFunc;
  long Variable;
  long NumberVar;

  displayfptverbose ("TransFunc\n");

  displayfptverbose ("  MAX_VAR    : %ld\n", TransFunc->MAX_VAR);
  displayfptverbose ("  NUMBER_VAR : %ld\n", TransFunc->NUMBER_VAR);

  NumberVar = TransFunc->NUMBER_VAR;
  VarFunc = TransFunc->VAR_FUNC;

  for (Variable = 0; Variable < NumberVar; Variable++)
    {
      displayfptverbose ("  VAR_FUNC[ %ld ] : ", Variable);

  fprintf (stdout, "\nVAR : ");
  fptViewBddNode ((&VarFunc[Variable])->VAR);
  fprintf (stdout, "FUNC: ");
  fptViewBddNode ((&VarFunc[Variable])->FUNC);
    }

}

